﻿ if(!window.PT){window.PT=new Object();window.PT["buildVersion"]='5667.145';window.PT["dbg"]='';window.PT["host"]='http://forums.abcnews.go.com';window.PT.IncludeScript=function(scriptUrl){var headElm=document.getElementsByTagName('head')[0];var scriptElm=document.createElement('script');scriptElm.setAttribute('type','text/javascript');scriptElm.setAttribute('src',scriptUrl);headElm.appendChild(scriptElm);}}


/**
    Prospero Active Widgets
    Copyright (c) 2007 Prospero Technologies LLC
    
    Prospero Active Widgets are dynamic elements of Prospero-served community or social media content embedded in
    web pages served by Prospero clients or their affilliates.
    Each Active Widget may use a token  named  "__WIDGET_ID__" to deal with namespacing
    The __WIDGET_ID__ is the unique key passed back to the server and is used as a key to reference the Widget in the registry
**/

 
function PT_WidgetMan()
{
  /**
  singleton if one already exists then use it
  **/
  if(window.PT_WIDGET_MAN)
  {
    /**
      If the WidgetMan object exists already then exit
    **/
    return;
  }
  window.PT_WIDGET_MAN = this;
  this.Widgets = new Object();
  this.Apps = new Object();
  /* TODO - load this up from infrastructure; perhaps move to PT? */
  this.Apps["forum"] = '/n/pfx/forum.aspx';
  this.element_count = 0;
  this.element_max = 3;
  this.onDOMLoad();
  this.awTopMessageTip = new PT_ToolTip();
  
}
  

function PT_WidgetMan_LoadWidgets()
{
  /* Stop after reaching the max allowed */
  if(this.element_max == this.element_count) { 
    return;
  }
  
  /* Scan for all widgets and kick off each */
  var elements = document.getElementsByTagName("paw:widget");
  var len = elements.length;
  
  for(var elementIndex = 0; elementIndex <len; elementIndex++)
  {
    /* Stop after reaching the max allowed */
    if(this.element_max == this.element_count) { 
      return;
    }
    var cModule = new PT_Widget(elements[elementIndex]);
    var cWidgetId = cModule.__WIDGET_ID__;
    this.Widgets[cWidgetId] = cModule;
    cModule.Load();
  }
}


function PT_WidgetMan_UpdateContent(moduleId, uri)
{
    if(this.Widgets[moduleId])
  {
        this.Widgets[moduleId].Update(PT["host"] + uri);
    }
}


function PT_WidgetMan_SetContent(moduleId,sContent)
{
    //alert("Setting content for widget " + moduleId);
    if(this.Widgets[moduleId])
    {
        this.Widgets[moduleId].SetContent(sContent);
    }
}


/**
 Determine if request is coming from:
  0. External Domain
  1. Same Domain
  2. Same Host
**/
function PT_WidgetMan_GetEnvironment()
{
  // Test Same Host
  if(PT["host"] == window.location.host)
  {
    return 2;
  }
  // Test Same Domain
  else 
  { 
    // This assumes that ajaxHost is a fully qualified domain name.
    // To Do: Probably should use a regular expression to tighten this up
    var ajaxHost = PT["host"].split('//');
    var ajaxDomain = ajaxHost[1].split('\.');
    var xhrDomain = window.location.host.split('\.');
    for(i = 0; i < xhrDomain.length - 1; i++)
    {
      for(j = 1; j < ajaxDomain.length - 1; i++)
      {
        if(xhrDomain[i] == ajaxDomain[j]);
        {
          return 1;
        }
      }
    }
    // Must be an External Domain
    return 0;
  }
}


function PT_WidgetMan_OnDOMLoad()
{
  /* Create callback function for readystate check */
  var self = this;
  var callback = function(){
    if(document.readyState == "complete")
    {
      clearInterval(timerPollDom);
      self.loadWidgets();
    }
  };
  
  /* If browser supports W3C Recommended event listener */
  if(document.addEventListener)
  {
    /* If Opera, and Safari, listen to OnReadyState by 'polling' it every second */
    if(document.readyState) 
    {
      // Poll readyState every second to see the DOM is complete 
      var timerPollDom = setInterval(callback, 1000);
    }
    /* Else Firefox, listen to DOMContentLoaded */
    else
    {
      document.addEventListener("DOMContentLoaded", function(){ self.loadWidgets(); }, false);
    }
  }
  /* Else the browser supports IE event listener */
  else if(document.attachEvent) 
  {
    document.attachEvent("onreadystatechange", callback);
  }
  /* Else the browser is very old */
  else
  {
    window.onload = self.loadWidgets;
  }
}


PT_WidgetMan.prototype = new Object();
PT_WidgetMan.prototype.getEnvironment = PT_WidgetMan_GetEnvironment;
PT_WidgetMan.prototype.loadWidgets = PT_WidgetMan_LoadWidgets;
PT_WidgetMan.prototype.onDOMLoad = PT_WidgetMan_OnDOMLoad;
PT_WidgetMan.prototype.SetContent = PT_WidgetMan_SetContent;
PT_WidgetMan.prototype.UpdateContent = PT_WidgetMan_UpdateContent;




function PT_Widget(Element)
{
    /* Generate a unique ID for the widget */
    this.__WIDGET_ID__ = PT_Widget.Prefix + PT_WIDGET_MAN.element_count++;
    this._Element=Element;
    
    /* The canvas will be the dynamically created div in which the widget operates */
    this._Canvas = null;
        
    this._DebugCanvas = null;
    this._debug= false;

    this.app = this._Element.getAttribute("app");
    if (!this.app || this.app == "")
    {
      this.app = "forum"; /* default */
    }
    //alert(this.app);
    this.webtag= this._Element.getAttribute("webtag");
    this.type = this._Element.getAttribute("type");
    this.args = this._Element.getAttribute("args");
    this.config = this._Element.getAttribute("config");
          
    this._script= null;
    this._errorMessage= "";
   
}



function PT_Widget_SetError(msg){
    this._errorMessage= msg;
    alert(this._errorMessage);
}

function  PT_Widget_SetContent(sContent)
{
    // modification to handle scripts
  if(this._Element)
  {
    //alert("I'm tired.  I need to catch my breath!");
    <!-- Needed to correct IE race condition -->
    var pawParent;
    if(this._Element.parentNode)
    {
      pawParent = this._Element.parentNode;
      //alert("pawParent by parentNode");
    }
    /*
    else
    {
      pawParent = document.getElementById("ptcWidgetParent");
      //alert("pawParent by getElementById");
    }
    */
    if(pawParent)
    {
      //alert("has parentNode");
      if(this._Canvas == null)
      {
        this._LoadingMessage = document.getElementById("ptcloading");
        if(this._LoadingMessage)
        {
            this._LoadingMessage.style.display = "none";
        }
        this._Canvas = document.createElement("div");
        pawParent.replaceChild(this._Canvas,this._Element);            
        this._Element= this._Canvas;
        //alert("Element: " + this._Element + "\nCanvas: " + this._Canvas);
      }
      this._Canvas.innerHTML = sContent;
      if(this._debug)
      {
         this._DebugCanvas= document.createElement("textarea");
         this._DebugCanvas.setAttribute("cols","50");
         this._DebugCanvas.setAttribute("rows","10");
         this._Canvas.appendChild(this._DebugCanvas);
         this._DebugCanvas.value=sContent;
      }
    }
  }
}


function PT_Widget_Load()
{
   var src = PT["host"] + PT_WIDGET_MAN.Apps[this.app] + "?webtag=" + this.webtag + "&widgetId="+ this.__WIDGET_ID__ +"&nav=jsscontent&dst="+escape(new Date().toString()); 
   if (this.type && this.type != "")
   {
      src += "&type=" + this.type;
   }
   if (this.args && this.args != "")
   {
      /* 4/30/07: Fix semicolon in subject title encoding issue */
      this.args = this.args.replace(/\%3B/g,'%20');
      /* Remove any < or > */
      this.args = this.args.replace(/\%3[Cc]/g,'%20');
      this.args = this.args.replace(/\%3[Ee]/g,'%20');
      this.args = this.args.replace(/\</g,'%20');
      this.args = this.args.replace(/\>/g,'%20');
      src += "&args=" + this.args;
   }
   if (this.config && this.config != "")
   {
      src += "&config=" + this.config;
   }
   var dbg = PT["dbg"];
   if (dbg && dbg != "")
   {
      src += "&dbg=" + dbg;
   }
   this.Update(src);
}
function PT_Widget_Update(src)
{
   if(this._script)
   {
    /* remove previously used script.  Someday we might make a history of scripts */ 
    document.body.removeChild(this._script);
    this._script= null;
   }
   this._script = document.createElement("script");
   this._src= src;
   //debug
   //alert(this._src);
   //window.open(this._src);
   this._script.setAttribute("src", this._src);
   document.body.appendChild(this._script);   
} 


PT_Widget.prototype                  = new Object();
PT_Widget.prototype.Load             = PT_Widget_Load;
PT_Widget.prototype.SetError         = PT_Widget_SetError;
PT_Widget.prototype.SetContent = PT_Widget_SetContent;
PT_Widget.prototype.Update = PT_Widget_Update;

PT_Widget.Prefix="PTWidget";
PT_Widget.rev =0;


function PT_ToolTip()
    {
	
		this.ptToolTipBox = document.createElement("div");
		this.id = "ptToolTip";
		this.ptToolTipBox.style.position = "absolute";
		this.ptToolTipBox.style.visibility = "hidden";
		this.ptToolTipBox.className = "ptToolTipBox";
	
		this.ptToolTipText = document.createElement("div");
		this.ptToolTipText.style.position = "relative";
		this.ptToolTipText.className = "ptToolTipText";
	
		this.ptToolTipBox.appendChild(this.ptToolTipText);
		this.msgs = new Object();
    	}
	


function PT_ToolTipShowMsg(msg, e)
    {
    
      if (msg)
      {
      this.ptShowTip(msg, e);
      }
    }

function PT_ToolTipShow(msg, e)
{
  var posx = 0;
  var posy = 0;
  if(e == null)
  {
  e = window.event;
  }

  if(e.pageX || e.pageY)
  {
    posx = e.pageX;
    posy = e.pageY;
    }
    else if(e.clientX || e.clientY)
    {
    if(document.documentElement.scrollTop)
    {
    posx = e.clientX+document.documentElement.scrollLeft;
    posy = e.clientY+document.documentElement.scrollTop;
    }
    else
    {
    posx = e.clientX+document.body.scrollLeft;
    posy = e.clientY+document.body.scrollTop;
    }
  }
  
  // Testing
  //for(var m in this.msgs)
  //{
  //  alert(m);
  //}

  //this.ptToolTipText.innerHTML = this.msgs['msg'+msg];
  this.ptToolTipText.innerHTML = msg;
  this.ptToolTipBox.style.top = posy + 10 + "px";
  this.ptToolTipBox.style.left = posx + 10 + "px";
  this.ptToolTipBox.style.visibility = "visible";
  if(this.ptToolTipBox.parentNode != document.body)
  {
  document.getElementsByTagName("body")[0].appendChild(this.ptToolTipBox);
  }
 
}

function PT_ToolTipHide()
{
this.ptToolTipBox.style.visibility = "hidden";
}

PT_ToolTip.prototype = new Object();
PT_ToolTip.prototype.ptHideTip = PT_ToolTipHide;
PT_ToolTip.prototype.ptShowTip = PT_ToolTipShow;
PT_ToolTip.prototype.ptShowTipMsg = PT_ToolTipShowMsg;
   
  
  
     
    
    
/** 
    Create the singleton global object window.PT_WIDGET_MAN which does all the work of module creation registration and execution
**/
 
new PT_WidgetMan();


//