var abcdm=abcdm||{};
abcdm.abccom=abcdm.abccom||{};
abcdm.abccom.Player=abcdm.abccom.Player||{};

(function($) {
	var isPlayerReady = false;
	var aPlayerList = new Array();
	
	var embedStatus = false;
	var embedCounter = 0;
	var embedMaxCount = 24;
	var embedLeadCount = 10;
	var socialLoaded = false;
	
	function widgetChecker() {
		if(embedCounter < embedMaxCount){
			if(videoAutoStart == 'true'){//let the player call loadSocial or timeout
				if(videoPlaying){
					//do nothing
				}
			}else if((abcdm.abccom.Player.isPlayerReady == true)&&(embedCounter == embedLeadCount)){//no autostart, allow player to setup for x tries
				embedStatus = true;
			}
			embedCounter++;
		}else if(embedCounter==embedMaxCount) {
			embedStatus=true;
		}
		
		if(embedStatus){
			clearInterval(runWidgets);
			loadSocial();
		}
	}
	
	runWidgets = setInterval(widgetChecker,1000);
	
	function loadSocial() {
		if(document.getElementById('stk-video')) {
			fbSocialKit();
		}
		if(document.getElementById('sd-video')){
			renderFBTweetDigg();
		}
		socialLoaded = true;
	}
	
	abcdm.abccom.Player.initialize = function() {
		this.isPlayerReady = false;
	};

	abcdm.abccom.Player.getPlayers = function( aPlayers ) {
		if( aPlayers!=null ) {
			if( typeof aPlayers.toLowerCase()=='string' ){
				if( aPlayers.toLowerCase()!='all' )
                    return aPlayers.split(',');
			}
		}
		return aPlayerList;
	};

	abcdm.abccom.Player.play = function( aPlayers, oOptions ) {
		aPlayers = this.getPlayers( aPlayers );
		for (p in aPlayers) {
			try{
				if(aPlayers[p]) this.getSWFApp(aPlayers[p]).jsToSWF( 'play', oOptions );
			} catch(e){
				//
			}
		}
	};
	
	abcdm.abccom.Player.pause = function( aPlayers ) {
		aPlayers = this.getPlayers( aPlayers );
		for (p in aPlayers) {
			try{
				if(aPlayers[p]) this.getSWFApp(aPlayers[p]).jsToSWF( 'pause' );
			} catch(e){
				//
			}
		}
	};
	
	abcdm.abccom.Player.resume = function( aPlayers ) {
		aPlayers = this.getPlayers( aPlayers );
		for (p in aPlayers) {
			try{
				if(aPlayers[p]) this.getSWFApp(aPlayers[p]).jsToSWF( 'resume' );
			} catch(e){
				//
			}
		}
	};

	abcdm.abccom.Player.stop = function( aPlayers ) {
		aPlayers = this.getPlayers( aPlayers );
		for (p in aPlayers) {
			try{
				if(aPlayers[p]) this.getSWFApp(aPlayers[p]).jsToSWF( 'stop' );
			} catch(e){
				//
			}
		}
	};

	abcdm.abccom.Player.playerReady = function() {
		this.isPlayerReady = true;
		this.readyForList = true;
	};
	
	videoPlaying = false;

	abcdm.abccom.Player.startPlaying = function() {
		videoPlaying = true;
	};
	
	abcdm.abccom.Player.adStartPlaying = function() {
		//console.log("PlayercalledadStartPlaying");
		videoPlaying = true;
		this.readyForList = false;
		
		if(!embedStatus){
			clearInterval(runWidgets);
			loadSocial();
			embedStatus = true;
		}
	};
	abcdm.abccom.Player.adEndPlaying = function() {
		//console.log("adEndPlaying");
		this.readyForList = true;
		companionAd = document.getElementById('companionAd');
		if(companionAd){
			companionAd.innerHTML = '<div id="adCompanionBanner300x250"></div>';
		}
	};

	abcdm.abccom.Player.endPlaying = function() {
		//console.log("PlayercalledEndPlaying");
		
	};

	abcdm.abccom.Player.refreshinfo = function( aPlayers, oOptions ) {
		aPlayers = this.getPlayers( aPlayers );
		for (p in aPlayers) {
			try{
				if(aPlayers[p]) this.getSWFApp(aPlayers[p]).jsToSWF( 'refreshinfo', oOptions );
			} catch(e){
				//
			}
		}
	};
	
	abcdm.abccom.Player.getSWID = function() {
		//call function for getting user's SWID;
		return abcdm.abccom.Utils.getSwid();
	};
	
	abcdm.abccom.Player.getSWFApp = function( appName ) {
		if (navigator.appName.indexOf ("Microsoft") !=-1) {
			return window[appName];
		} else {
			return document[appName];
		}
	};
	
	abcdm.abccom.Player.addPlayer = function( appName ) {
		if( typeof appName.toLowerCase()=='string' ){
			aPlayerList.push(appName);
		}
	};
	
	abcdm.abccom.Player.redrawPlayer = function( divId ) {
		if ($(divId)) {
			$(divId).css('visibility','hidden');
			tout = setTimeout(
				function() {
					if(tout) clearTimeout(tout);
					if($(divId)){
						$(divId).css('visibility','visible');
						//console.log("delayed called");
					}
				},5000);
			//console.log('redraw called');
		}
	};
	
	$(document).ready(function() {
		// DOMReady code...
	});
	
})(jQuery);