if(typeof gSafeOnload == "undefined"){
	var gSafeOnload = new Array(0);
	var gSafeOnunload = new Array(0);
	var gSafeResize = new Array(0);
	var isWindowLoaded = false;	
	
	function SafeOnload()
	{	var func;
		isWindowLoaded = true;
		while(gSafeOnload.length>0){
			try{
				func = gSafeOnload.shift();
				func();
			}
			catch(e){}
		}
	}
	
	function SafeOnunload()
	{	var func;
		while(gSafeOnunload.length>0){
			try{
				func = gSafeOnunload.shift();
				func();
			}
			catch(e){}
		}
	}
	
	if (window.onload != SafeOnload){
		if  ((typeof window.onload) == "function"){
			gSafeOnload.push(window.onload);
		}
		window.onload = SafeOnload;
	}
	if (window.onunload != SafeOnunload){
		if  ((typeof window.onunload) == "function"){
			gSafeOnunload.push(window.onunload);
		}
		window.onunload = SafeOnunload;
	}
	function addOnload(f){	
		if(!isWindowLoaded){
			gSafeOnload.push(f);
		}
		else{
			f();
		}
	}
	
	function addOnunload(f){	
		gSafeOnunload.push(f);
	}
	
	addOnload(function(){
		var el = getBodyElement();
		var indicators = getElementsWithAttribute(el,'class','loading-indicator');
		for(var i=0;i<indicators.length;i++){
			indicators[i].style.display="none";
		}
	});
	
	function addResize(f){	
		gSafeResize.push(f);
	}
	
	function SafeResize(){
		var len = gSafeResize.length;
		for(var i=0;i<len;i++){
			gSafeResize[i]();
		}
	}
	
	if (window.onresize != SafeResize){
		if  ((typeof window.onresize) == "function"){
			addResize(window.onresize);
		}
		window.onresize = SafeResize;
	}
	
	/*document.onkeydown = function(evt){
		if(!evt) var evt = event;
		var target = evt.target ? evt.target : evt.srcElement;
		//if keydown target is not a form input, focus the search box
		if(target == null || (typeof target.value=='undefined') || target.type=='image'){
			var el = document.getElementById('searchtext');
			if(el!=null){
				if(isAlphaChar(evt)){
					el.focus();
				}
			}
		}
	}*/
	
	function isAlphaChar(evt){
		if(!evt) var evt = event;
		return !evt.altKey && !evt.ctrlKey && evt.keyCode >=65 && evt.keyCode <=90;
	}
	
	function getEventTarget(evt){
        var targ;
        if (!evt) var evt = window.event;
        if (evt.target) targ = evt.target;
        else if (evt.srcElement) targ = evt.srcElement;
        if (targ.nodeType == 3) // defeat Safari bug
                targ = targ.parentNode;
        return targ;
	}
	
	function descendsFrom(el,ancestor){
		try{
		 	while(el.parentNode!=null){
		 		if(el.parentNode == ancestor) return true;
		 		el=el.parentNode;
		 	}
	 	}
	 	catch(e){}
	 	return false;
	 }
	 
	 function stopEvent(e){
    	if(!e){
    		e = event;
    	}
    	 e.cancelBubble = true;
         if (e.stopPropagation) { e.stopPropagation(); }
         if (e.preventDefault) {e.preventDefault();}
    }
    
    function absLeft(e){
    	if (!e) var e = window.event;
    	if (e.pageX ){
    		return e.pageX;
    	}
    	else if(e.clientX){
    		return e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
    	}
    }
    
    function absTop(e){
    	if (!e) var e = window.event;
    	if (e.pageY ){
    		return e.pageY;
    	}
    	else if(e.clientY){
    		return e.clientY + document.body.scrollTop + document.documentElement.scrollTop;
    	}
    }
    
    //dim = "Left" or "Top"
    function calcPosition(object, dim){
        var tmpElt = object;
        var pos = 0;
        while(tmpElt != null &&  tmpElt.tagName != "BODY" ) {
        	pos += parseInt(tmpElt["offset" + dim]);
            tmpElt = tmpElt.offsetParent;
        }
        return pos;
    }
    
     //dim = "Left" or "Top"
    function calcPosition(object, dim, ancestor){
        var tmpElt = object;
        var pos = 0;
        while(tmpElt != null &&  tmpElt != ancestor ) {
        	pos += parseInt(tmpElt["offset" + dim]);
            tmpElt = tmpElt.offsetParent;
        }
        return pos;
    }
    
    function getHeadElement(){
    	var head = document.getElementsByTagName('head')[0];
		if(head==null){
			head = document.getElementsByTagName('body')[0];
		}
		return head;
    }
    
    function getBodyElement(){
    	return document.getElementsByTagName('body')[0];
    }
    
    function createCookie(name,value,days,domain) {
		if (days) {
			var date = new Date();
			date.setTime(date.getTime()+(days*24*60*60*1000));
			var expires = "; expires="+date.toGMTString();
		}
		else var expires = "";
		
    		if(domain !=null && typeof domain != 'undefined'){
    			domain = "; domain=" + domain;
    		}	
      		
      		//alert("All: "+value+expires+domain+"; path=/");
      		
		document.cookie = name+"="+value+expires+domain+"; path=/";
	}
	
	function readCookie(name) {
		var nameEQ = name + "=";
		var ca = document.cookie.split(';');
		for(var i=0;i < ca.length;i++) {
			var c = ca[i];
			while (c.charAt(0)==' ') c = c.substring(1,c.length);
			if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
		}
		return null;
	}
	
	function tgSearch(tg) {
		var tgQuery = '';
		tgQueryVal = tg.searchtext.value;
		if(tgQueryVal.trim() == ''){
			tgQueryVal='ABC News';
		}
		var baseUrl = window.searchBaseUrl != null ? window.searchBaseUrl : 'http://abcnews.go.com';
		tgQuery = baseUrl+'/search?searchtext=' + encodeURIComponent(tgQueryVal);
		window.open(tgQuery,'_parent');
		return false;
	}
	
	function getUsersGreeting(staticBaseURL) {
	
		userFName = readCookie("USERFNAME")			
		
		if(isValidSWID() && isValidBLUE() &&  userFName != 'NRT') {
			if(userFName != null && userFName != 'null' && typeof userFName != 'undefined') {
				document.write("Welcome, " + userFName+" | ");
			}		
			document.write('<a href="http://abcnews.go.com/assets/globalLogout.html">Sign Out</a>');
		}
		else {
			document.write("<a href=\"https://register.go.com/global/abcnews/register?appRedirect="+escape(document.URL)+"\">Register</a> | ");
			document.write("<a href=\"https://register.go.com/global/abcnews/login?rd=true&appRedirect="+escape(document.URL)+"\">Sign In</a>");
			//document.write("<a href=\"\">&nbsp;&nbsp;(What's This?)</a>");
			
		}
	}

	function isValidIcaughtReg() {
		var ICAUGHTREG = readCookie("ICAUGHTREG");
		
		if(isValidSWID() && isValidBLUE() && ICAUGHTREG != null) {
			return true;
		}
		else {
			return false;
		}
	}
	function isValidSWID() {
		var SWID = readCookie("SWID");
		if(SWID != null) {
			SWID = SWID.toString();
		}
		if(SWID != null && SWID.length != 0 && SWID.charAt(0) == '{' && SWID.charAt(SWID.length-1) == '}') {
			return true;
		}
		else {
			return false;
		}
	}	
	function isValidBLUE() {
		var BLUE = readCookie("BLUE");
		//alert("BLUE: "+BLUE);
		if(BLUE != null && BLUE != 'null' && typeof BLUE != 'undefined') {
			return true;
		}
		else {
			return false;
		}
	}
	function eraseCookie( name, path, domain ) {

		if ( readCookie( name ) ) {
			document.cookie = name + '=' +
				( ( path ) ? ';path=' + path : '') +
				( ( domain ) ? ';domain=' + domain : '' ) +
				';expires=Thu, 01-Jan-1970 00:00:01 GMT';
		}
	}
	
	function setOpacity(object, opacity) {
		if(object){
			object.style.opacity = (opacity == 1 ? 0.99 : opacity);
			object.style.MozOpacity = (opacity == 1 ? 0.99 : opacity);
			object.style.KhtmlOpacity = opacity;
			if (object.style.setAttribute) {
				if(opacity==1){
					object.style.setAttribute("filter","");
				}
				else{
					object.style.setAttribute("filter",  "progid:DXImageTransform.Microsoft.Alpha(opacity=" + (opacity * 100) + ")");
				}
			}
		}
	}
	
	function getOpacity(object){
		if(object){
			if(object.style.display == 'none')
				return 0;
			if(object.style.opacity)
				return parseFloat(object.style.opacity);
			if(object.style.MozOpacity)
				return parseFloat(object.style.MozOpacity);
			if(object.style.KhtmlOpacity)
				return parseFloat(object.style.KhtmlOpacity);
			if(object.style.filter){
				var opacity = object.style.filter.match(/alpha\(opacity=(.*)\)/i);
				if(opacity[1]) return parseFloat(opacity[1]) / 100;
			}
		}
		return 1.0;
	}

	function getElementById(el,id){
		if(!isEmpty(el)){
			if(el.id && el.id == id){
				return el;
			}
			var eid = el.attributes ? el.attributes['id'] : null;
			if(eid && eid==id){
				return el;
			}
			if(el.childNodes){
				var len = el.childNodes.length;
				var cn, tel;
				for(var i=0;i<len;i++){
					cn = el.childNodes[i];
					if(cn.nodeType==1){
						tel = getElementById(cn,id);
						if(tel){
							return tel;
						}
					}
				}
			}
		}
		else{
			return document.getElementById(id);
		}
		return null;
	}
	
	function getElementsWithAttribute(el,name,value){
	 	var array = new Array();
	 	if(el!=null){
			var attr = el.getAttribute(name);
			if((typeof attr != "undefined") && attr==value){
				array[array.length]=el;
			}
			else if (name=='class' && (el.className==value)){
				array[array.length]=el;
			}
			var len = el.childNodes.length;
			var child;
			for(var i=0;i<len;i++){
				child = el.childNodes[i];
				if(child.nodeType==1){
					array = array.concat(getElementsWithAttribute(child,name,value));
				}
			}
	 	}
	 	return array;
	 }
	 
	function removeEventHandlers(el,recurse){
		el.onclick=null;
		el.ondblclick=null;
		el.onmousedown=null;
		el.onmouseup=null;
		el.onmouseover=null;
		el.onmouseout=null;
		el.onmouseenter=null;
		el.onmouseleave=null;
		el.onkeydown=null;
		el.onkeypress=null;
		el.onkeyup=null;
		el.onblur=null;
		el.onfocus=null;
		el.oncontextmenu=null;
		el.onmousemove=null;
		el.onchange=null;
		el.onreset=null;
		el.onselect=null;
		el.onsubmit=null;
		if(recurse){
			var i,child;
			var len = el.childNodes.length;
			for(i=0;i<len;i++){
				child = el.childNodes[i];
				if(child.nodeType==1){
					removeEventHandlers(child,recurse);
				}
			}
		}
	}
	
	function openPopup(url, name, width, height, features) {
		var newurl = url.toLowerCase();
		if (newurl.indexOf('playerindex') != -1 || newurl.indexOf('videologin') != -1) { //full window
			var popup = window.open(url);
			popup.focus();
		} else { //popup
			adjH = (height<635)?20:0;
			adjW = (width<741)?60:0;
			adjW = ((width<743)&&(width>741))?58:adjW;
			var winFeatures = (features) ? "," + features : "";
			var xPos = (screen.availWidth) / 2 - (width / 2);
			var yPos = (screen.availHeight / 2) - (height / 2);
			var winAttribs = "width=" + (width+adjW) + ",height=" + (height+adjH) + ",left=" + xPos + ",top=" + yPos + winFeatures;
			var popup = window.open(url, name, winAttribs);
			popup.focus();
		}
			
	}

	function isEmpty(arg){
		return (!arg || arg==null);
	}
	//fix IE flicker
	try{
		document.execCommand("BackgroundImageCache", false ,true);
	}
	catch(e){}
	function qsParam(keyParam) {
		var query = window.location.search.substring(1);
		var parms = query.split('&');
		for (var i=0; i<parms.length; i++) {
			var pos = parms[i].indexOf('=');
			if (pos > 0) {
				var key = parms[i].substring(0,pos);
				if(keyParam == key) {
					return parms[i].substring(pos+1);
				}
			}
		}
		return null;
	}	
	
	function loadScript(url){
		var head = getHeadElement();
		var script = document.createElement('script');
		script.setAttribute("type", "text/javascript"); 
		script.src = url;
		head.appendChild(script); 
	}
	
	abcNewsObj = new Object();
	abcNewsObj.strip = function(){
		for(n=1;n<arguments.length;n++){	
			this.tagTmp = document.getElementsByTagName(arguments[n]);
			for(i=0;i<this.tagTmp.length;i++){
				this.tmp = this.tagTmp[i];
				this.tmp1 = this.tmp.childNodes[0];
				this.tmp1.parentNode.removeChild(this.tmp1);
			}
		}
	}
	
}
//// Add array methods
if(!Array.prototype.shift) { // if this method does not exist..
	Array.prototype.shift = function(){
        firstElement = this[0];
        this.reverse();
        this.length = Math.max(this.length-1,0);
        this.reverse();
        return firstElement;
	}   
}
if(!Array.prototype.unshift) { // if this method does not exist..
    Array.prototype.unshift = function(){
		this.reverse();
		for(var i=arguments.length-1;i>=0;i--){
			this[this.length]=arguments[i]
		}
		this.reverse();
		return this.length
	}
}
if(!Array.prototype.push) { // if this method does not exist..
	Array.prototype.push = function(){
		for(var i=0;i<arguments.length;i++){
			this[this.length]=arguments[i];
		}
       	return this.length;
    }     
}
if(!Array.prototype.pop) { // if this method does not exist..
	Array.prototype.pop = function(){
		lastElement = this[this.length-1];
		this.length = Math.max(this.length-1,0);
		return lastElement;
    }
}
if(!Array.prototype.remove) {
	Array.prototype.remove = function(obj){
		for(var i=0;i<this.length;i++){
			if(this[i] == obj){
				this.slice(i,1);
				i--;
				this.length = Math.max(this.length-1,0);
			}
		}
	}
}
if(!Array.prototype.binarySearch) {
	Array.prototype.binarySearch = function(item,comparator){
	  var left = -1,
		  right = this.length,
		  mid,
		  comp;
	
	  while(right - left > 1)
	  {
		mid = (left + right) >>> 1;
		comp = comparator.compare(item,this[mid]);
		if(comp == 0)
		  return mid;
		else if(comp > 0)
		  left = mid;
		else
		  right = mid;
	  }
	
	  if(comparator.compare(item,this[right]) != 0)
		return -(right + 1);
	
	  return right;
	}
}
if(!String.prototype.trim){
	String.prototype.trim = function () {
	    return this.replace(/^\s*/, "").replace(/\s*$/, "");
	}
}

function textCounter(field,maxlimit) {
	if (field.value.length > maxlimit){
	alert ('A maximum of ' + maxlimit + ' characters is allowed.');
	field.value = field.value.substring(0, maxlimit);
	}
}

	function loadDeferredImages(selector){
				$(selector).each(function() {
				var $this = $(this);
				if($this.attr("_src")){
					$this.attr("src", $this.attr("_src")).removeAttr("_src");
				}
			});
		}/**
 * pane.js - a collection of methods for asynchronous markup loading and presentation management
 * author: Alex Vigdor
 **/
if(typeof allPanesOnPage=='undefined'){
var allPanesOnPage = new Object();
var urlLoaderBase = '/javascript/loadmarkup?include=';
// a place to store Markup objects that cache content on or off screen
var urlMarkupFragments = new Object();
// urlMarkupListeners[url] = Array of callback functions with signature function(Markup)
var urlMarkupListeners = new Object();
//a place to store temporary dynamic script tags
var scriptElements = new Object();

//remove event handlers on unload
addOnunload(function(){
	var url, markup,pane,id;
	for(url in urlMarkupFragments){
		markup = urlMarkupFragments[url];
		markup.destroy();
		urlMarkupFragments[url]=null;
	}
	for(id in allPanesOnPage){
		pane=allPanesOnPage[id];
		pane.destroy();
		allPanesOnPage[id]=null;
	}
});

// this is the callback function for dynamic markup loaders
function setMarkup(url, markup){
	//alert('setting markup '+markup+' for '+url);
	url = url.toLowerCase();
	var mo = urlMarkupFragments[url];
	if(mo == null){
		mo = new Markup();
		urlMarkupFragments[url] = mo;
	}
	mo.setMarkup(markup);
	notifyListeners(url,mo);
	removeScriptTag(url);
	return mo;
}

function notifyListeners(url, markup){
	var listeners = urlMarkupListeners[url];
	if(listeners != null){
		while(listeners.length > 0){
			listeners.shift()(markup);
		}
	}
}

function removeScriptTag(url){
	var script = scriptElements[url];
	if(script != null){
		script.parentNode.removeChild(script);
		scriptElements[url]=null;
	}
}

/**
 * Kick off an asynchronous markup loader request
 * maxage = maximum age in milliseconds of cached content (-1 for no expiration)
 * callback = function that takes a single Markup object as an argument
 **/
function getMarkup(url, maxage, callback){
	var callbackURL = makeCallbackURL(url).toLowerCase();
	if(callback!=null){
		var listeners = urlMarkupListeners[callbackURL];
		if(listeners == null){
			listeners = new Array();
			urlMarkupListeners[callbackURL] = listeners;
		}
		listeners.push(callback);
	}
	var mo = urlMarkupFragments[callbackURL];
	if((mo!= null) && (mo.isLoaded()) && (maxage >= 0) && (mo.getAge() > maxage)){
		mo = null;
	}
	if(mo==null){
		mo = new Markup();
		urlMarkupFragments[callbackURL] = mo;
		var head = document.getElementsByTagName('head')[0];
		if(head==null){
			head = document.getElementsByTagName('body')[0];
		}
		var script = document.createElement('script');
		script.setAttribute("type", "text/javascript"); 
		script.src = makeScriptSrc(url);
		head.appendChild(script); 
		scriptElements[callbackURL] = script;
	}
	else if(mo.isLoaded()){
		notifyListeners(callbackURL,mo);
	}
}

function makeCallbackURL(url){
	var rx = new RegExp('^http(?:s)?://.*\?include=(.+)');
	var m = rx.exec(url);
	if(m!=null){
		return decodeURIComponent(m[1]);
	}
	else{
		return url;
	}
}

function makeScriptSrc(url){
	if(url.match(/^http(s)?:\/\//)){
		return url;
	}
	else{
		var b = urlLoaderBase+encodeURIComponent(url);
		if(url.match(/^\/meta\//)){
			b = '/meta'+b;
		}
		return b;
	}
}

/**
 * Represents a markup fragment, with a notion of age and a DOM element cache
 * Arguments: 
 **/
function Markup(){
	this.markup = null;
	this.contentElement = null;
	this.loaded = null;
	this.scripts = new Array();
}

Markup.prototype.getContentElement = function(){
	if(this.contentElement == null){
		this.parse();
	}
	return this.contentElement;
}

Markup.prototype.getAge = function(){
	return new Date().getTime() - this.loaded.getTime();	
}

Markup.prototype.parse = function(){
	if(this.contentElement == null){
		var el = document.createElement('div');
		el.innerHTML = this.markup;
		this.contentElement = el;
	}
}

Markup.prototype.isLoaded = function(){
	return this.markup !=null;
}

Markup.prototype.setMarkup = function(markup){
	this.destroy();
	this.markup = this.extractJS(markup);
	this.loaded = new Date();
}

Markup.prototype.destroy = function(){
	if(this.contentElement!=null){
		removeEventHandlers(this.contentElement,true);
		this.contentElement=null;
	}
	for(var i=0;i<this.scripts.length;i++){
		this.scripts[i].destroyScript();
	}
	this.scripts = new Array();
	this.markup=null;
	this.loaded=null;
}


/**
 *	This function uses regular expressions to find script tags in the string of markup;
 *  it will load each script tag into a scriptHolder, and remove the tag from the
 *  markup string.  The marjkup string with all scripts removed is returned.
 *  This should be executed before the markup string is set.
 **/
Markup.prototype.extractJS = function(markup){
	var scriptMatcher = /<script [^>]*?(?:(type|src)\s*=\s*(["'])(.*?)\2)\s*(?:(type|src)\s*=\s*(["'])(.*?)\5)?[^>]*?>([\s\S]*?)<\/script>/mi;
	while((match = scriptMatcher.exec(markup)) != null){
		var sh = new ScriptHolder();
		if(match[1]){
			sh[match[1]] = match[3];
		}
		if(match[4]){
			sh[match[4]] = match[6];
		}
		if(match[7]){
			sh.text = match[7].replace(/\s*[\n]\s*/g,'\n');
			sh.text = sh.text.replace(/[ \t]+/g,' ');
		}
		this.scripts.push(sh);
		markup = markup.replace(match[0],'\n');
	}
	return markup;
}

function ScriptHolder(){
	this.type = null;
	this.src = null;
	this.text = null;
	this.el = null;
}

ScriptHolder.prototype.deployScript = function(){
  if(this.el==null){
	this.el = document.createElement("script");
    this.el.type = "text/javascript";
    if(this.src == null){
    	if(this.text != null){	
    		try{
    			this.el.appendChild(document.createTextNode(this.text));
    		}
    		catch(e){
    			//IE throws an exception here, but supports the text property as an alternative
    			this.el.text = this.text;
    		}
	    }
	}
	else{
		this.el.src = this.src;
	}
	getHeadElement().appendChild(this.el);
  }
}

ScriptHolder.prototype.destroyScript = function(){
	if(this.el != null){
		getHeadElement().removeChild(this.el);
		this.el = null;
	}
}

//given a DOM object, cycle through its ancestors until you find one 
//whose ID corresponds to a known pane.
function findPane(obj){
	var par = obj;
	while(par!=null){
		var id = par.id;
		if(id!=null){
			var pane = getPane(id);
			if(pane!=null){
				return pane;
			}
		}
		par = par.parentNode;
	}
}

function getPane(id){
	return allPanesOnPage[id];
}

function getContainedPanes(obj){
	var list = new Array(0);
	getContainedPanesRecursive(obj,list);
	return list;
}

function getContainedPanesRecursive(obj,arr){
	if(obj.firstChild!=null){
		var len = obj.childNodes.length;
		for(var i=0;i<len;i++){
			var node = obj.childNodes[i];
			if(node.nodeType == 1){
				if(node.id && allPanesOnPage[node.id]){
					arr.push(allPanesOnPage[node.id]);
				}
				getContainedPanes(node,arr);
			}
		}
	}
}

function Pane(id){
	this.id = id;
	this.host = document.getElementById(id);
	allPanesOnPage[id]=this;
	this.markup;
	//what is the maximum age allowed for content in this pane in milliseconds
	this.maxage=600000;
	this.currentURL = null;
	//Should this pane automatically reload its contents when the maxage is exceeded?
	this.autoReload = false;
	this.timer=null;
	this.transition = null;
	
	this.shell = document.createElement('div');
	this.shell.style.position="absolute";
	this.shell.style.overflow="hidden";
	this.host.appendChild(this.shell);
	
	this.viewport = document.createElement('div');
	this.viewport.style.position="absolute";
	this.viewport.style.overflow = "hidden";
	
	this.shell.appendChild(this.viewport);
	this.staging = document.createElement('div');
	this.staging.style.position="absolute";
	this.staging.style.visibility="hidden";
	this.shell.appendChild(this.staging);
	this.content= null;
	this.contentHeight=0;
	this.contentWidth = 0;
	this.oldContent = null;
	//var resize = makePaneResize(this);
	//addOnload(resize);
	//addResize(resize);
	
	this.minScroll=10;
	this.scrollbarWidth = 17;
	this.scrollbarBorderWidth = 0;
	this.scrollFirstInterval = 300;
	this.scrollInterval=20;
	this.scrollFactorX = 1;
	this.scrollFactorY = 1;
	this.engaged = false;
	this.disengageTimer = null;
	this.scrollTimer = null;
	this.currentAnimation = null;
	
	this.ismouseover=false;
	this.statechanges = new Array();
	this.mouseovers = new Array();
	this.mouseouts = new Array();
	this.mousedowns = new Array();
	this.mousewheels = new Array();
	this.engages = new Array();
	this.disengages =  new Array();
	this.onloads = new Array();
	this.onloader = makePaneOnloader(this);
	
	this.shell.onmouseover = makePaneMouseOver(this);
	this.shell.onmouseout = makePaneMouseOut(this,this.host);
	this.shell.onmousedown = makePaneMouseDown(this);
	this.shell.onmousewheel = makeScrollWheel(this);
	if (this.shell.addEventListener){
		this.shell.addEventListener('DOMMouseScroll', this.shell.onmousewheel, false);
	}
	
}

Pane.prototype.scrape = function(url){
	if(urlMarkupFragments[url.toLowerCase()] != null){
		return;
	}
	var fragment = document.createElement("div");
	var removeList = new Array();
	for(var i=0;i<this.host.childNodes.length;i++){
		var node = this.host.childNodes[i];
		if(node!=this.shell){
			removeList.push(node);
			fragment.appendChild(node.cloneNode(true));
		}
	}
	var fhtml = fragment.innerHTML;
	if(fhtml.replace(/^\s*/, "").replace(/\s*$/, "").length > 0){
		setMarkup(url,fhtml);
		while(( d = removeList.pop()) != null){
			this.host.removeChild(d);
		}
		this.loadURL(url);
		var d;
		
	}
}

Pane.prototype.destroy = function(){
	this.shell.onmouseover=null;
	this.shell.onmousoeut=null;
	this.shell.onmousedown=null;
	if (this.shell.addEventListener){
		this.shell.removeEventListener('DOMMouseScroll', this.shell.onmousewheel,false);
	}
	this.shell.onmousewheel=null;
	this.shell=null;
	this.content=null;
	this.oldContent = null;
	this.staging=null;
	this.viewport=null;
	this.host=null;
	if(this.yscrollbar != null){
		this.ytrough.onmousedown=null;
		this.upscroller.onmousedown=null;
		this.downscroller.onmousedown=null;
		this.yscrollbar=null;
		this.yscroller=null;
		this.yscrollertop=null;
		this.yscrollerbottom=null;
		this.ytrough=null;
		this.upscroller=null;
		this.downscroller=null;
	}
	if(this.xscrollbar != null){
		this.xtrough.onmousedown=null;
		this.leftscroller.onmousedown=null;
		this.rightscroller.onmousedown=null;
		this.xscrollbar=null;
		this.xscroller=null;
		this.xscrollerleft=null;
		this.xscrollerright=null;
		this.xtrough=null;
		this.leftscroller=null;
		this.rightscroller=null;
	}
}

function makePaneResize(pane){
	var pane = pane;
	return function(){
		try{
			pane.resize();
		}
		catch(e){alert(e.message)}
	}
}
//indicate whether user is currently interacting with this pane
Pane.prototype.engage = function(){
	if(!this.engaged){
		this.engaged = true;
		//run this panes engage handlers, and disengage other panes
		var len = this.engages.length;
    	for(var i=0;i<len;i++){
    		this.engages[i]();
    	}
    	for(id in allPanesOnPage){
    		if(id != this.id){
    			allPanesOnPage[id].disengage();
    		}
    	}
	}
}

Pane.prototype.disengage = function(){
	if(this.engaged){
		this.engaged=false;
		var len = this.disengages.length;
    	for(var i=0;i<len;i++){
    		this.disengages[i]();
    	}
	}
}

Pane.prototype.resize = function(){
	this.getHostDimensions();
	this.refreshScrollbars();
	this.display();
}


//the purpose of this method is to resize the pane according to the size of the host element
Pane.prototype.getHostDimensions = function(){
	this.width=this.host.clientWidth;
	if(this.width == 0 && this.host.currentStyle && this.host.currentStyle.width!=null){
		var w = parseInt(this.host.currentStyle.width);
		if(!isNaN(w)){
			this.width=w;
		}
	}
	this.height=this.host.clientHeight;
	if(this.height == 0 && this.host.currentStyle && this.host.currentStyle.height!=null){
		var h = parseInt(this.host.currentStyle.height);
		if(!isNaN(h)){
			this.height=h;
		}
	}
	this.shell.style.width = this.width+"px";
	this.shell.style.height = this.height+"px";
	this.viewport.style.width = this.width+"px";
	this.viewport.style.height = this.height+"px";
	this.viewportWidth=this.width;
	this.viewportHeight=this.height;
}

Pane.prototype.refreshScrollbars = function(){
	if(this.yscrollbar != null){
		this.yscrollbar.style.width = (this.scrollbarWidth - 2*this.scrollbarBorderWidth) + "px";
		this.yscrollbar.style.left = (this.width - this.scrollbarWidth )+"px";
	}
	if(this.xscrollbar != null){
		this.xscrollbar.style.height = (this.scrollbarWidth - 2*this.scrollbarBorderWidth) + "px";
		this.xscrollbar.style.top = (this.height - this.scrollbarWidth)+"px";
	}
}

Pane.prototype.setViewportWidth = function(width){
	this.viewportWidth = width;
	this.viewport.style.width = width+"px";	
}

Pane.prototype.setViewportHeight = function(height){
	this.viewportHeight = height;
	this.viewport.style.height = height+"px";
}

Pane.prototype.stageContent = function(){
	if(!this.width){
		this.getHostDimensions();
	}
	if(this.content != null){
		this.oldContent = this.content;
	}
	this.content = this.markup.getContentElement();
	this.content.style.position="absolute";
	this.content.style.top="0px";
	this.content.style.left="0px";
	this.content.style.overflow="visible";
	this.content.style.width = "";
	this.content.style.height = "";
	while(this.staging.firstChild != null){
		this.staging.removeChild(this.staging.firstChild);
	}
	if(this.xscrollbar!=null && this.yscrollbar == null){
		this.staging.style.height = this.viewportHeight+"px";
	}
	else{
		this.staging.style.width = this.viewportWidth+"px";
	}
	this.staging.appendChild(this.content);
	this.contentWidth = this.content.clientWidth;
	this.contentHeight = this.content.clientHeight;
	this.content.style.width = (this.contentWidth)+"px";
	this.content.style.height = (this.contentHeight)+"px";
	this.staging.removeChild(this.content);
	this.scrollFactorY = this.contentHeight/this.viewportHeight;
	this.scrollFactorX = this.contentWidth/this.viewportWidth;
}

Pane.prototype.redrawScrollbars = function(){
	if(this.yscroller!=null){
		var yh = this.yscroller.style.top;
	}
	this.content.style.width = "";
	this.content.style.height = "";
	this.contentWidth = this.content.clientWidth;
	this.contentHeight = this.content.clientHeight;
	this.content.style.width = (this.contentWidth)+"px";
	this.content.style.height = (this.contentHeight)+"px";
	this.scrollFactorY = this.contentHeight/this.viewportHeight;
	this.scrollFactorX = this.contentWidth/this.viewportWidth;
	this.renderScrollbars();
	if(this.yscroller!=null){
		this.yscroller.style.top = yh;
	}
}

Pane.prototype.addEngage = function(handler){
	this.engages.push(handler);
}

Pane.prototype.removeEngage = function(handler){
	this.engages.remove(handler);
}

Pane.prototype.addDisengage = function(handler){
	this.disengages.push(handler);
}

Pane.prototype.removeDisengage = function(handler){
	this.disengages.remove(handler);
}

Pane.prototype.addOnload = function(handler){
	this.onloads.push(handler);
}

Pane.prototype.removeOnload = function(handler){
	this.onloads.remove(handler);
}

Pane.prototype.addMouseOver = function(handler){
	this.mouseovers.push(handler);
}

Pane.prototype.addMouseOut = function(handler){
	this.mouseouts.push(handler);
}

Pane.prototype.addMouseDown = function(handler){
	this.mousedowns.push(handler);
}

Pane.prototype.addStateChange = function(handler){
	this.statechanges.push(handler);
}

Pane.prototype.removeStateChange = function(handler){
	this.statechanges.remove(handler);
}

Pane.prototype.removeMouseDown = function(handler){
	this.mousedowns.remove(handler);
}

Pane.prototype.removeMouseOver = function(handler){
	this.mouseovers.remove(handler);
}

Pane.prototype.removeMouseOut = function(handler){
	this.mouseouts.remove(handler);
}

Pane.prototype.addMouseWheel = function(handler){
	this.mousewheels.push(handler);
}

Pane.prototype.removeMouseWheel = function(handler){
	this.mousewheels.remove(handler);
}

function makeScrollWheel(pane){
	var pane = pane;
	return function(e){
		if(!e){
    		var e = event;
    	}
    	var returnval = true;
    	var len = pane.mousewheels.length;
    	for(var i=0;i<len;i++){
    		if(!pane.mousewheels[i](e)){
    			returnval = false;
    		}
    	}
    	if(!returnval){
    		stopEvent(e);
    	}
    	return returnval;
	}
}

function makePaneMouseDown(pane){
	var pane = pane;
	return function(e){
		if(!e){
    		var e = event;
    	}
    	var returnval = true;
   		var len = pane.mousedowns.length;
    	for(var i=0;i<len;i++){
    		if(!pane.mousedowns[i](e)){
    			returnval = false;
    		}
    	}
    	if(!returnval){
    		stopEvent(e);
    	}
    	return returnval;
	}
}


function makePaneMouseOver(pane){
	var pane = pane;
	return function(e){
		if(!e){
    		var e = event;
    	}
    	var returnval = true;
    	if(!pane.ismouseover){
    		pane.ismouseover = true;
    		var len = pane.mouseovers.length;
	    	for(var i=0;i<len;i++){
	    		if(!pane.mouseovers[i](e)){
	    			returnval = false;
	    		}
	    	}
    	}
    	if(!returnval){
    		stopEvent(e);
    	}
    	return returnval;
	}
}

function makePaneMouseOut(pane,ancestor){
	var pane = pane;
	return function(e){
		if(!e){
    		var e = event;
    	}
    	var returnval = true;
    	if(pane.ismouseover){
    		var landing = e.relatedTarget || e.toElement;
    		if(landing==null || !descendsFrom(landing,ancestor)){
    			pane.ismouseover = false;
			var len = pane.mouseouts.length;
			for(var i=0;i<len;i++){
				if(!pane.mouseouts[i](e)){
					returnval = false;
				}
			}
    		}
    	}
    	if(!returnval){
    		stopEvent(e);
    	}
    	return returnval;
	}
}

Pane.prototype.reload = function(){
	if(this.currentURL != null){
		this.loadURL(this.currentURL);
	}
}

Pane.prototype.setTransition = function(trans){
	this.transition = trans;
}

Pane.prototype.loadURL = function(url,callback,transition){
	if(this.timer != null){
		window.clearTimeout(this.timer);
		this.timer = null;
	}
	this.currentURL = url;
	this.processStateChange('loading');
	getMarkup(url,this.maxage,makePaneCallback(this,callback,transition));
}

Pane.prototype.setAutoReload = function(bool){
	this.autoReload = bool;
}

Pane.prototype.setMarkup = function(markup,transition){
	this.cancelAnimation();
	if(this.markup!=null){
		this.unloadScripts();
	}
	this.markup = markup;
	this.display(transition);
}

Pane.prototype.display = function(transition){
	if(this.markup){
		this.processStateChange('displaying');
		this.stageContent();
		this.renderScrollbars();
		if(!transition && this.transition){
			transition = this.transition;
		}	
		if(transition){
			transition.addCallback(this.onloader);
			this.animate(transition);
		}
		else{
			this.doOnload();
		}
	}
}

function makePaneOnloader(pane){
	var pane = pane;
	return function(){
		pane.doOnload();
	}
}

Pane.prototype.doOnload = function(){
	var cn = this.viewport.childNodes;
	var cnl = cn.length;
	var node, i;
	for(i=cnl-1;i>=0;i--){
		node = cn[i];
		if(node!=this.content){
			this.viewport.removeChild(node);
		}
	}
	if(this.content.parentNode != this.viewport){
		this.viewport.appendChild(this.content);
	}
	this.loadScripts();
	var len = this.onloads.length;
	for(i=0;i<len;i++){
		this.onloads[i]();
	}
	this.processStateChange('done');
}

Pane.prototype.cancelAnimation = function(){
	if(this.currentAnimation !=null && this.currentAnimation.running){
		if(masterAnimationController){
			masterAnimationController.cancel(this.currentAnimation);
		}
		else{
			this.currentAnimation.cancel(true);
		}
	}
}

Pane.prototype.animate = function(animation){
	this.currentAnimation = animation;
	this.currentAnimation.reset();
	if(masterAnimationController){
		masterAnimationController.animate(this.currentAnimation);
	}
	else{
		this.currentAnimation.run();
	}
}

Pane.prototype.processStateChange = function(state){
	var len = this.statechanges.length;
   	for(var i=0;i<len;i++){
   		this.statechanges[i](state);
   	}
}

Pane.prototype.loadScripts = function(){
	var len = this.markup.scripts.length;
	for(var i=0;i<len;i++){
		this.markup.scripts[i].deployScript();
	}
}

Pane.prototype.unloadScripts = function(){
	var len = this.markup.scripts.length;
	for(var i=0;i<len;i++){
		this.markup.scripts[i].destroyScript();
	}
}

Pane.prototype.setMaxAge = function(millis){
	this.maxage = millis;
}

function makePaneCallback(pane,callback,transition){
	var pane = pane;
	var callback = callback;
	var transition = transition;
	return function(markup){
		var docallback = (typeof callback == 'function');
		if(!transition && pane.transition){
			transition = pane.transition;
		}	
		if(!isEmpty(transition)){
			transition.reset();
		}
		if(pane.markup==null || markup.markup != pane.markup.markup){
			if(transition){
				if(docallback){
					transition.addCallback(callback);
					docallback=false;
				} 
			}
			//pane.setTransition(transition);
			pane.setMarkup(markup,transition);
		}
		else{
			pane.processStateChange('displaying');
			pane.processStateChange('done');
		}
		if(docallback){
			callback();
		}
		if(pane.autoReload){
			var waitTime = pane.maxage - markup.getAge();
			pane.timer = window.setTimeout(makePaneReload(pane),waitTime);
		}
		pane=null;
		callback=null;
		transition=null;
	}
}

function makePaneReload(pane){
	var pane = pane;
	return function(){
		pane.reload();
	}
}

//create a sequence to cross fade from oldContent to newContent
Pane.prototype.makeCrossFadeSequence = function(){
	var seq = new Sequence();
	var pane = this;
	seq.handler = function(val){
		setOpacity(pane.content,val);
	};
	seq.init = function(){
		if(pane.content && pane.content.parentNode != pane.viewport){
			setOpacity(pane.content,seq.start);
			pane.viewport.appendChild(pane.content);
			pane.content.style.zIndex=3;
		};
		if(!isEmpty(pane.oldContent)){
			pane.oldContent.style.zIndex=2;
		}
	}
	seq.callback = function(){
		if(pane.content!=pane.oldContent && pane.oldContent && pane.oldContent.parentNode==pane.viewport){
			setOpacity(pane.oldContent,1-seq.end);
			pane.oldContent.style.zIndex="";
			pane.viewport.removeChild(pane.oldContent);
		}
		if(!isEmpty(pane.content)){
			pane.content.style.zIndex="";
		}
	}
	return seq;
}
//create a sequence with the appropriate init function to set start and end values to animate a scroll
Pane.prototype.makeYScrollSequence = function(elementProducer){
	var seq = new Sequence();
	seq.init = makeYScrollSequenceInit(this,seq,elementProducer);
	return seq;
}

Pane.prototype.makeXScrollSequence = function(elementProducer){
	var seq = new Sequence();
	seq.init = makeXScrollSequenceInit(this,seq,elementProducer);
	return seq;
}

function makeYScrollSequenceInit(pane,seq,elementProducer){
	var scrollpane = pane;
	var seq = seq;
	var elementProducer = elementProducer;
	return function(){
		var el = elementProducer();
		if(el && scrollpane.content){
			var offset = calcPosition(el,"Top",scrollpane.content);
			var min = -scrollpane.content.offsetTop;
			var max = min+scrollpane.viewportHeight;
			if((offset + el.offsetHeight ) > max){
				offset+=el.offsetHeight;
			}
			if(offset >= min && offset <= max){
				seq.handler= null;
				return;
			}
			
			seq.start = scrollpane.content.offsetTop;
			seq.end = (-offset > seq.start) ? -offset : -offset+scrollpane.viewportHeight;
			var pane = scrollpane;
			var direction = seq.end-seq.start;
			seq.handler = function(val){
				var amount = Math.round((pane.content.offsetTop-val)/pane.scrollFactorY);
				if((amount < 0 && (direction>0)) || (amount > 0 && (direction<0))){
					pane.scrolly(amount);
				}
			}
		}
		else{
			seq.handler=null;
		}
	}
}

function makeXScrollSequenceInit(pane,seq,elementProducer){
	var scrollpane = pane;
	var seq = seq;
	var elementProducer = elementProducer;
	return function(){
		var el = elementProducer();
		if(el && scrollpane.content){
			var offset = calcPosition(el,"Left",scrollpane.content);
			var min = -scrollpane.content.offsetLeft;
			var max = min+scrollpane.viewportWidth;
			if((offset + el.offsetWidth ) > max){
				offset+=el.offsetWidth;
			}
			if(offset >= min && offset <= max){
				seq.handler= null;
				return;
			}
			
			seq.start = scrollpane.content.offsetLeft;
			seq.end = (-offset > seq.start) ? -offset : -offset+scrollpane.viewportWidth;
			var pane = scrollpane;
			var direction = seq.end-seq.start;
			seq.handler = function(val){
				var amount = Math.round((pane.content.offsetLeft-val)/pane.scrollFactorX);
				if((amount < 0 && (direction>0)) || (amount > 0 && (direction<0))){
					pane.scrollx(amount);
				}
			}
		}
		else{
			seq.handler=null;
		}
	}
}

Pane.prototype.renderScrollbars = function(){
	var x = false;
	var y = false;
	var xw = this.width-(2*this.scrollbarBorderWidth);
	var yh = this.height-(2*this.scrollbarBorderWidth);
	
	var ovw = this.viewportWidth;
	var ovh = this.viewportHeight;
	
	if(this.contentHeight > this.height && this.yscrollbar){
		y = true;
		this.setViewportWidth(this.width - this.scrollbarWidth);
	}
	else{
		this.setViewportWidth(this.width);
	}
	if(ovw != this.viewportWidth){
		this.stageContent();
	}
	if(this.contentWidth > this.width && this.xscrollbar){
		x=true;
		this.setViewportHeight(this.height - this.scrollbarWidth);
	}
	else{
		this.setViewportHeight(this.height);
	}
	if(ovh != this.viewportHeight){
		this.stageContent();
	}
	if(y && x){
		xw -= this.scrollbarWidth;
		yh -= this.scrollbarWidth;
	}
	if(y){
		this.yscrollbar.style.height = yh+"px";
		var ytroughheight = yh-(2*(this.scrollbarWidth-(2*this.scrollbarBorderWidth)));
		this.ytrough.style.height = ytroughheight+"px";
		this.ytrough.style.top = (this.scrollbarWidth-(2*this.scrollbarBorderWidth))+"px";
		var nyh = (ytroughheight*(yh/this.contentHeight));
		this.yscroller.style.height = nyh+'px';
		this.yscroller.style.top="0px";
		this.downscroller.style.top = (yh-this.scrollbarWidth+(2*this.scrollbarBorderWidth))+"px";
		this.yscrollbar.style.display = "block";
		this.yscrollerbottom.style.top  = nyh - this.yscrollerbottom.offsetHeight+"px";
	}
	else if(this.yscrollbar){
		this.yscrollbar.style.display = "none";
	}
	if(x){
		this.xscrollbar.style.width = xw+"px";
		var xtroughwidth = xw-(2*(this.scrollbarWidth-(2*this.scrollbarBorderWidth)));
		this.xtrough.style.width = xtroughwidth+"px";
		this.xtrough.style.left = this.scrollbarWidth-(2*this.scrollbarBorderWidth)+"px";
		this.xscroller.style.width = (xtroughwidth*(xw/this.contentWidth))+'px';
		this.xscroller.style.left="0px";
		this.rightscroller.style.left = (xw-this.scrollbarWidth+(2*this.scrollbarBorderWidth))+"px";
		this.xscrollbar.style.display = "block";
	}
	else if(this.xscrollbar){
		this.xscrollbar.style.display = "none";
	}
	
}


Pane.prototype.addXScrollbar = function(){
	this.getHostDimensions();
	
	this.xscrollbar = document.createElement("div");
	this.xscrollbar.className = "xScrollbar";
	this.xscrollbar.style.position="absolute";
	this.xscrollbar.style.height = (this.scrollbarWidth - 2*this.scrollbarBorderWidth) +"px";
	this.xscrollbar.style.margin="0px";
	this.xscrollbar.style.padding="0px";
	this.xscrollbar.style.display = "none";
	
	this.xscroller = document.createElement("div");
	this.xscroller.className = "xScroller";
	this.xscroller.style.position="relative";
	this.xscroller.style.fontSize = "1px"
	this.xscroller.style.height = "17px";
	this.xscroller.onmousedown = makeScrollOnMouseDownX(this);
	
	this.xscrollerleft = document.createElement("div");
	this.xscrollerleft.className = "xScrollerCapLeft";
	this.xscrollerleft.style.cssFloat="left";
	this.xscrollerleft.style.styleFloat="left";
	this.xscrollerleft.style.top = "0px";
	this.xscrollerleft.style.fontSize = "1px";
	this.xscroller.appendChild(this.xscrollerleft);
	
	this.xscrollerright = document.createElement("div");
	this.xscrollerright.className = "xScrollerCapRight";
	this.xscrollerright.style.cssFloat="right";
	this.xscrollerright.style.styleFloat="right";
	this.xscrollerright.style.fontSize = "1px";
	this.xscroller.appendChild(this.xscrollerright);
	
	this.xtrough = document.createElement("div");
	this.xtrough.className = "xTrough";
	this.xtrough.style.position="absolute";
	this.xtrough.style.height = (this.scrollbarWidth - 2*this.scrollbarBorderWidth) +"px";
	this.xtrough.appendChild(this.xscroller);
	this.xtrough.onmousedown = makeScrollPagerX(this);
	this.xscrollbar.appendChild(this.xtrough);
	
	var pane = this;
	var scrollstopper = makeScrollStopper(pane);
	
	this.leftscroller = document.createElement("div");
	this.leftscroller.className = "leftScroller";
	this.leftscroller.style.height = (this.scrollbarWidth - 2*this.scrollbarBorderWidth)+"px";
	this.leftscroller.style.width = (this.scrollbarWidth - 2*this.scrollbarBorderWidth)+"px";
	this.leftscroller.style.position="absolute";
	this.leftscroller.style.fontSize = "1px";
	this.leftscroller.style.left = "0px";
	this.leftscroller.onmousedown = function(){
		var func = makeLeftScroll(pane,pane.scrollFirstInterval);
		func();
		document.onmouseup = scrollstopper;
	};
	this.xscrollbar.appendChild(this.leftscroller);
	
	this.rightscroller = document.createElement("div");
	this.rightscroller.className = "rightScroller";
	this.rightscroller.style.height = (this.scrollbarWidth - 2*this.scrollbarBorderWidth)+"px";
	this.rightscroller.style.width = (this.scrollbarWidth - 2*this.scrollbarBorderWidth)+"px";
	this.rightscroller.style.position="absolute";
	this.rightscroller.style.fontSize = "1px";
	this.rightscroller.onmousedown = function(){
		var func = makeRightScroll(pane,pane.scrollFirstInterval);
		func();
		document.onmouseup = scrollstopper;
	};
	this.xscrollbar.appendChild(this.rightscroller);
	
	this.shell.appendChild(this.xscrollbar);
	this.refreshScrollbars();
}

function makeScrollStopper(pane){
	var pane = pane;
	return function(){
		window.clearTimeout(pane.scrollTimer);
		document.onmouseup=null;
	}
}

function makeLeftScroll(pane,time){
	this.pane=pane;
	this.time = time;
	return function(){
		pane.scrollLeft();
		var func = makeLeftScroll(pane,pane.scrollInterval);
		pane.scrollTimer =window.setTimeout(func,time);
	}
}

function makeRightScroll(pane,time){
	this.pane=pane;
	this.time = time;
	return function(){
		pane.scrollRight();
		var func = makeRightScroll(pane,pane.scrollInterval);
		pane.scrollTimer =window.setTimeout(func,time);
	}
}

function makeUpScroll(pane,time){
	this.pane=pane;
	this.time = time;
	return function(){
		pane.scrollUp();
		var func = makeUpScroll(pane,pane.scrollInterval);
		pane.scrollTimer =window.setTimeout(func,time);
	}
}

function makeDownScroll(pane,time){
	this.pane=pane;
	this.time = time;
	return function(){
		pane.scrollDown();
		var func = makeDownScroll(pane,pane.scrollInterval);
		pane.scrollTimer =window.setTimeout(func,time);
	}
}

Pane.prototype.addYScrollbar = function(){
	this.getHostDimensions();
	this.yscrollbar = document.createElement("div");
	this.yscrollbar.className = "yScrollbar";
	this.yscrollbar.style.position="absolute";
	this.yscrollbar.style.top="0px";
	this.yscrollbar.style.display = "none";
	
	this.yscroller = document.createElement("div");
	this.yscroller.className = "yScroller";
	this.yscroller.style.position="absolute";
	this.yscroller.style.width = "17px";
	this.yscroller.onmousedown = makeScrollOnMouseDownY(this);
	this.yscrollbar.appendChild(this.yscroller);
	
	this.yscrollertop = document.createElement("div");
	this.yscrollertop.className = "yScrollerCapTop";
	this.yscrollertop.style.position="absolute";
	this.yscrollertop.style.top = "0px";
	this.yscrollertop.style.fontSize = "1px";
	this.yscroller.appendChild(this.yscrollertop);
	
	this.yscrollerbottom = document.createElement("div");
	this.yscrollerbottom.className = "yScrollerCapBottom";
	this.yscrollerbottom.style.position="absolute";
	this.yscrollerbottom.style.fontSize = "1px";
	this.yscroller.appendChild(this.yscrollerbottom);
	
	this.ytrough = document.createElement("div");
	this.ytrough.className = "yTrough";
	this.ytrough.style.position="absolute";
	this.ytrough.style.width = (this.scrollbarWidth - 2*this.scrollbarBorderWidth) +"px";
	this.ytrough.appendChild(this.yscroller);
	this.ytrough.onmousedown = makeScrollPagerY(this);
	this.yscrollbar.appendChild(this.ytrough);
	
	var pane = this;
	var scrollstopper = makeScrollStopper(pane);
	
	this.upscroller = document.createElement("div");
	this.upscroller.className = "upScroller";
	this.upscroller.style.height = (this.scrollbarWidth - 2*this.scrollbarBorderWidth)+"px";
	this.upscroller.style.width = (this.scrollbarWidth - 2*this.scrollbarBorderWidth)+"px";
	this.upscroller.style.position="absolute";
	this.upscroller.style.fontSize = "1px";
	this.upscroller.style.top = "0px";
	this.upscroller.onmousedown = function(){
		var func = makeUpScroll(pane,pane.scrollFirstInterval);
		func();
		document.onmouseup = scrollstopper;
	};
	this.yscrollbar.appendChild(this.upscroller);
	
	this.downscroller = document.createElement("div");
	this.downscroller.className = "downScroller";
	this.downscroller.style.height = (this.scrollbarWidth - 2*this.scrollbarBorderWidth)+"px";
	this.downscroller.style.width = (this.scrollbarWidth - 2*this.scrollbarBorderWidth)+"px";
	this.downscroller.style.position="absolute";
	this.downscroller.style.fontSize = "1px";
	this.downscroller.onmousedown = function(){
		var func = makeDownScroll(pane,pane.scrollFirstInterval);
		func();
		document.onmouseup = scrollstopper;
	};
	this.yscrollbar.appendChild(this.downscroller);
	
	this.shell.appendChild(this.yscrollbar);
	this.addMouseWheel(makeScrollOnMouseWheel(this));
	this.refreshScrollbars();
}

Pane.prototype.scrollUp = function(){
	this.scrolly(-Math.ceil(this.minScroll/this.scrollFactorY));
}

Pane.prototype.scrollDown = function(){
	this.scrolly(Math.ceil(this.minScroll/this.scrollFactorY));
}

Pane.prototype.scrollLeft = function(){
	this.scrollx(-Math.ceil(this.minScroll/this.scrollFactorX));
}

Pane.prototype.scrollRight = function(){
	this.scrollx(Math.ceil(this.minScroll/this.scrollFactorX));
}

Pane.prototype.scrolly = function(delta){
	if(this.yscrollbar && this.yscrollbar.style.display=='block'){
		var originy = this.yscroller.offsetTop;
		var top = originy+delta;
		if(top < 0){
			top = 0;
		}
		var max = this.ytrough.clientHeight - this.yscroller.offsetHeight;
		if(top > max){
			top = max;
		}
		if(top!=originy){
			this.yscroller.style.top = top+"px";
			
			this.content.style.top = (-(this.contentHeight-this.viewportHeight)*(top/max))+"px";
			return false;
		}
		return false;
	}
	return true;
}

Pane.prototype.scrollx = function(delta){
	if(this.xscrollbar && this.xscrollbar.style.display=='block'){
		var originx = this.xscroller.offsetLeft;
		var left = originx+delta;
		if(left < 0){
			left = 0;
		}
		var max = this.xtrough.clientWidth - this.xscroller.offsetWidth;
		if(left > max){
			left = max;
		}
		if(left!=originx){
			this.xscroller.style.left = left+"px";
			
			this.content.style.left = (-(this.contentWidth-this.viewportWidth)*(left/max))+"px";
			return false;
		}
		return false;
	}
	return true;
}

Pane.prototype.pageUp = function(){
	return this.scrolly(-((this.yscroller.offsetHeight) - 2*(this.minScroll/this.scrollFactorY)));
}

Pane.prototype.pageDown = function(){
	return this.scrolly(((this.yscroller.offsetHeight) - 2*(this.minScroll/this.scrollFactorY)));
}

Pane.prototype.pageLeft = function(){
	return this.scrollx(-((this.xscroller.offsetWidth) - 2*(this.minScroll/this.scrollFactorX)));
}

Pane.prototype.pageRight = function(){
	return this.scrollx(((this.xscroller.offsetWidth) - 2*(this.minScroll/this.scrollFactorX)));
}


function makeScrollPagerY(scrollpane){
	var scrollpane = scrollpane;
	
	return function(e){
		if (!e) var e = window.event;
		if(absTop(e) < calcPosition(scrollpane.yscroller,"Top")){
			scrollpane.pageUp();
		}
		else if(absTop(e) > (calcPosition(scrollpane.yscroller,"Top") + scrollpane.yscroller.offsetHeight)){
			scrollpane.pageDown();
		}
	};
}

function makeScrollPagerX(scrollpane){
	var scrollpane = scrollpane;
	
	return function(e){
		if (!e) var e = window.event;
		if(absLeft(e) < calcPosition(scrollpane.xscroller,"Left")){
			scrollpane.pageLeft();
		}
		else if (absLeft(e) > (calcPosition(scrollpane.xscroller,"Left") + scrollpane.xscroller.offsetWidth)){
			scrollpane.pageRight();
		}
	};
}

function makeScrollOnMouseWheel(scrollpane){
	var scrollpane = scrollpane;
	
	return function(e){
		var wheelDelta;
		if (e.wheelDelta) wheelDelta = e.wheelDelta / 120 * ((window.opera) ? 1 : -1);
		if (e.detail) wheelDelta = e.detail;
		if(wheelDelta < 0){
			wheelDelta = -2;
		}
		else{
			wheelDelta = 2;
		}	
		var rval = scrollpane.scrolly((wheelDelta*scrollpane.minScroll)/scrollpane.scrollFactorY);
		if(!rval){
			stopEvent(e);
		}
		return rval;
	}
}	

xScrollMouseDownTimer = null;
var clearx = function(){xScrollMouseDownTimer = null;};

function makeScrollOnMouseDownX(scrollpane){
	var scrollpane = scrollpane;
	
	return function(e){
		//prevent text selection on ie
		document.body.ondrag = function () { return false; };
    	document.body.onselectstart = function () { return false; };
		var originx = scrollpane.xscroller.offsetLeft;
	
		document.onmouseup = makeScrollOnMouseUp(scrollpane);
		var startx = absLeft(e);
		var minx = 1/scrollpane.minScroll;
		document.onmousemove = function(e){
			if(xScrollMouseDownTimer == null){
				var nx = absLeft(e);
				var delta = (nx-startx);
				if(Math.abs(delta) >= minx){
					xScrollMouseDownTimer = window.setTimeout(clearx,8);
					scrollpane.scrollx(delta);
					startx = nx;
				}
				
			}
			stopEvent(e);
		}
		return false;
	}
}

var yScrollMouseDownTimer = null;

function makeScrollOnMouseDownY(scrollpane){
	var scrollpane = scrollpane;
	
	return function(e){
		//prevent text selection on ie
		document.body.ondrag = function () { return false; };
    	document.body.onselectstart = function () { return false; };
		var originy = scrollpane.yscroller.offsetTop;
	
		document.onmouseup = makeScrollOnMouseUp(scrollpane);
		var starty = absTop(e);
		var cleary = function(){yScrollMouseDownTimer = null;};
		var miny = 1/scrollpane.minScroll;
		document.onmousemove = function(e){
			if(yScrollMouseDownTimer == null){
				var ny = absTop(e);
				var delta = (ny-starty);
				if(Math.abs(delta) >= miny){
					yScrollMouseDownTimer = window.setTimeout(cleary,8);
					scrollpane.scrolly(delta);
					starty = ny;			
				}
			}
			stopEvent(e);
		}
		return false;
	}
}

function makeScrollOnMouseUp(scrollpane){
	var scrollpane=scrollpane;
	return function(e){
		var starty = absTop(e);
		document.onmousemove = null;
		document.body.ondrag = null;
    	document.body.onselectstart = null;
		stopEvent(e);
	}
}
}
/**
 * A Playlist is a logical sequence of events that are played back on an interval cycle
 * author: Alex Vigdor     copyright 2007 ABCNews Internet Ventures
 **/
var allPlaylistsOnPage = new Object();

function pausePL(){
	for(id in allPlaylistsOnPage){
		allPlaylistsOnPage[id].pause();
	}
}
function resumePL(){
	for(id in allPlaylistsOnPage){
		allPlaylistsOnPage[id].resume();
	}
}

/**
 * A playlist item represents one step in the playlist.  It should have a handler
 * function that is executed when the item is on deck, another when it is activated,
 * and a third when it is deactivated 
 **/
function PlaylistItem(id){
	this.id = id;
	this.ondeck;
	this.activate;
	this.deactivate;
}

function Playlist(id,lifecycle){
	this.id = id;
	var old = allPlaylistsOnPage[this.id];
	this.paused=false;
	if(!isEmpty(old)){
		if(old.paused){
			this.paused=true;
		}
		old.destroy();
	}
	allPlaylistsOnPage[this.id] = this;
	this.playing=false;	
	this.preload=false;
	this.interval=1000;
	this.timer = null;
	this.items = new Array();
	this.currentItem = null;
	this.pointer = 0;
	this.inits = new Array();
	this.inited=false;
	this.destroys = new Array();
	this.destroyed=false;
}

Playlist.prototype.addInit = function(initFunc){
	this.inits.push(initFunc);
}

Playlist.prototype.addDestroy = function(destroyFunc){
	this.destroys.push(destroyFunc);
}

Playlist.prototype.destroy = function(){
	if(!this.destroyed){
		this.destroyed=true;
		this.pause();
		var len = this.destroys.length;
		for(var i=0;i<len;i++){
			this.destroys[i]();
		}
		var len = this.items.length;
		var item;
		for(var i=0;i<len;i++){
			item = this.items[i];
			if(typeof item.destroy == 'function'){
				item.destroy();
				this.items[i]=null;
			}
		}
	}
}

Playlist.prototype.next = function(){
	if(this.timer!=null){
		window.clearTimeout(this.timer);
		this.timer=null;
	}
	this.autoForward(arguments);
	return false;
}

Playlist.prototype.back = function(){
	if(this.timer!=null){
		window.clearTimeout(this.timer);
		this.timer=null;
	}
	if(this.pointer<2){
		this.pointer=this.items.length-(2-this.pointer);
		if(this.pointer < 0){
			this.pointer=0;
		}
	}
	else{
		this.pointer -= 2;
	}
	this.autoForward(arguments);
	return false;
}


Playlist.prototype.gotoItem = function(id){
	var len = this.items.length;
	for(var i=0;i<len;i++){
		if(this.items[i].id==id){
			if(this.currentItem==null || this.currentItem.id!=id){
				this.pointer = i;
				if(this.timer!=null){
					window.clearTimeout(this.timer);
					this.timer=null;
				}
				var args = new Array();
				for(var x=1;x<arguments.length;x++){
					args.push(arguments[x]);
				}
				this.autoForward(args);
			}
			return true;
		}
	}
	return false;
}

Playlist.prototype.prepare = function(id){
	var len = this.items.length;
	for(var i=0;i<len;i++){
		if(this.items[i].id==id){
			if(this.currentItem==null || this.currentItem.id!=id){
				if(this.items[i].ondeck){
					this.items[i].ondeck();
				}
			}
			break;
		}
	}
}

Playlist.prototype.play = function(){
	if(!this.playing){
		if(this.items.length > 0){
			if(!this.paused){
				this.playing=true;
			}
			this.autoForward(arguments);
		}
	}
}	

Playlist.prototype.resume = function(){
	if(!this.playing && this.paused){
		this.playing=true;
		this.paused=false;
		var pl = this;
		this.timer = window.setTimeout(function(){pl.autoForward();pl=null;},this.interval);
	}
}

Playlist.prototype.pause = function(){
	if(this.playing){
		this.playing=false;
		this.paused=true;
		if(this.timer!=null){
			window.clearTimeout(this.timer);
			this.timer=null;
		}
	}
}

Playlist.prototype.setPreload = function(bool){
	this.preload=bool;
}

Playlist.prototype.setInterval = function(millis){
	this.interval=millis;
}

Playlist.prototype.autoForward = function(args){
	if(!this.inited){
		this.inited=true;
		var len = this.inits.length;
		for(var i=0;i<len;i++){
			this.inits[i]();
		}
	}
	if(this.items.length > 0){
		if(this.currentItem != null && this.currentItem.deactivate){
			this.currentItem.deactivate();
		}
		this.currentItem = this.items[this.pointer];
		this.currentItem.activate(args);
		if(this.playing){
			var pl = this;
			this.timer = window.setTimeout(function(){pl.autoForward();pl=null},this.interval);
		}
		else{
			this.timer = null;
		}
		if(this.pointer==(this.items.length-1)){
			this.pointer=0;
		}
		else{
			this.pointer++;
		}
		//now prefetch the next item in the playlist
		if(this.playing){
			var nextItem = this.items[this.pointer];
			if(nextItem.ondeck){
				nextItem.ondeck();
			}
		}
	}
}

Playlist.prototype.addItem = function(item){
	this.items[this.items.length] = item;
	if(this.preload && item.ondeck ){
		var ref = item;
		addOnload(function(){ref.ondeck(); ref = null;});
	}
}

Playlist.prototype.addItems = function(array){
	this.items = this.items.concat(array);
	if(this.preload){
		var ar = array;
		addOnload(function(){
			var len = ar.length;
			var item;
			for(var i=0;i<len;i++){
				item = ar[i];
				if(item.ondeck){
					item.ondeck();
				}
			}
			ar = null;
		});
	}
}

/**
 * A UrlPlaylistManager encapsulates the functionality of a playlist which 
 * loads URLs into a pane from controls associated with element IDs
 **/
function UrlPlaylistManager(playlist){
	this.activeClass;
	this.inactiveClass;
	this.pane;
	this.playlist=playlist;
	this.transition = null;
	this.lookupProducer = function(){return null;};
	this.currentElement = null;
	if(!isEmpty(this.playlist)){
		var manager = this;
		this.playlist.addDestroy(function(){
			if(!isEmpty(manager.inactiveClass) && (manager.currentElement!=null)){
				manager.currentElement.className = manager.inactiveClass;
			}
			manager.currentElement=null;
			manager=null;
		});
	}
}

UrlPlaylistManager.prototype.addItem = function(id,url){
	this.playlist.addItem(new UrlPMItem(id,url,this));
}

UrlPlaylistManager.prototype.addItems = function(array){
	var items = new Array(array.length/2);
	var len = array.length;
	for(var i=0;i<len;i+=2){
		items[i/2] = new UrlPMItem(array[i],array[i+1],this);
	}
	this.playlist.addItems(items);
}

UrlPlaylistManager.prototype.updateCurrentItem = function(url){
	this.playlist.currentItem.url=url;
	this.playlist.currentItem.activate();
}

function UrlPMItem(id,url,manager){
	this.id=id;
	this.url=url;
	this.manager=manager;
	this.element = null;
}

UrlPMItem.prototype.getElement = function(){
	if(this.element == null){
		this.element =  getElementById(this.manager.lookupProducer(),this.id);
	}
	return this.element;
}

UrlPMItem.prototype.activate=function(args){
	var el = this.getElement();
	if(!isEmpty(el)){
		el.className = this.manager.activeClass;
		this.manager.currentElement = el;
	}
	var transition = ((!isEmpty(args) && args.length > 0 ) ? args[0] : this.manager.transition);
	if(!isEmpty(this.manager.pane) && !isEmpty(this.url)){
		this.manager.pane.loadURL(this.url,null,transition);
	}
};

UrlPMItem.prototype.deactivate = function(){
	var el= this.getElement();
	if(el){
		el.className = this.manager.inactiveClass;
		this.manager.currentElement = null;
	}
};

UrlPMItem.prototype.ondeck = function(){
	if(!isEmpty(this.manager.pane) && !isEmpty(this.url)){
		getMarkup(this.url,this.manager.pane.maxAge-this.manager.playlist.interval,function(markup){markup.parse()})
	}
};	

UrlPMItem.prototype.destroy = function(){
	this.element = null;
};
/**
 * animation.js - a lightweight framework for adaptive vector-based animations
 * author: Alex Vigdor
 *
 * An animation has a timeline.  This timeline is mapped by a SortedSet 
 * of TimedEvents which represent a specific point in time after the start of the animation,
 * and which point to one or more sequences to be launched at that moment.
 * Sequences define a logical vector from a start value to an end value, whose
 * intermediate values are passed to a handler function which can use the values to
 * update the screen (e.g. change opacity, position, etc.)
**/

function SortedSet(comparator){
	this.comparator = comparator;
	this.back = new Array();
	this.length = 0;
}

// return null, or pre-existing obj if already present
SortedSet.prototype.putIfAbsent = function(obj){
	var idx = this.back.binarySearch(obj,this.comparator);
	if(idx >= 0){
		return this.back[idx];
	}
	this.back.splice((Math.abs(idx) - 1),0,obj);
	
	this.length++;
	return null;
}

SortedSet.prototype.contains = function(obj){
	return (this.back.binarySearch(obj,this.comparator) >= 0);
}

SortedSet.prototype.indexOf = function(obj){
	return this.back.binarySearch(obj,this.comparator);
}

SortedSet.prototype.get = function(idx){
	return this.back[idx];	
}
SortedSet.prototype.remove = function(idx,cnt){
	if(!cnt){
		cnt=1;
	}
	if(idx>=0 && idx <this.length){
		var item
		this.back.splice(idx,cnt);
		this.length = this.length - cnt;
	}
}

function TimedEventComparator(){}

TimedEventComparator.prototype.compare = function(obj1,obj2){
	if(obj1 == null){
		if(obj2==null)
			return 0;
		else
			return 1;
	}
	else if(obj2==null){
		return -1;
	}
	if(obj1.time == obj2.time)
		return 0;
	if(obj1.time < obj2.time)
		return -1;
	if(obj1.time > obj2.time)
		return 1;
}

function TimedEvent(time){
	this.time = time;
	this.sequences = new Array();
}

function Animation(){
	this.events = new SortedSet(new TimedEventComparator());
	this.frameinterval = 10;
	this.eventPointer=0;
	this.startTime;
	this.activeSequences = new Array();
	this.callbacks = new Array();
	this.timer =  null;
	this.running=false;
	this.stepper = makeDoFrame(this);
}

Animation.prototype.clone = function(){
	var anim = new Animation();
	anim.events = this.events;
	anim.frameinterval = this.frameinterval;
	return anim;
}

Animation.prototype.cancel = function(doCallback){
	if(this.running){
		this.running=false;
		if(this.timer !=null){
			window.clearTimeout(this.timer);
			this.timer=null;
		}
		//run callbacks for all remaining sequences
		var activelen = this.activeSequences.length;
		var seq;
		for(var i=0;i<activelen;i++){
			seq = this.activeSequences[i];
			if(!isEmpty(seq.callback)){
				seq.callback();
			}
			seq['lastFrameVal'] = null;
		}
		this.activeSequences = new Array();
		var evt;
		for(var i=this.eventPointer;i<this.events.length;i++){
			evt = this.events.get(i);
			for(var j=0;j<evt.sequences.length;j++){
				seq = evt.sequences[j];
				if(!isEmpty(seq.callback)){
					seq.callback();
				}
				seq['lastFrameVal'] = null;
			}
		}
		if(doCallback){
			var callback;
			while((callback = this.callbacks.pop())!=null){
				callback();
			}
		}
		else{
			this.callbacks = new Array();
		}
	}
}

Animation.prototype.reset = function(){
	this.eventPointer = 0;
}

Animation.prototype.addCallback = function(callback){
	this.callbacks.push(callback);
}

Animation.prototype.run = function(){
	this.running=true;
	this.startTime = new Date().getTime();
	this.doFrame(this.startTime);
}

Animation.prototype.addSequence = function(millis,sequence){
	var ev = new TimedEvent(millis);
	var pe = this.events.putIfAbsent(ev);
	if(pe!=null){
		ev = pe;
	}
	ev.sequences.push(sequence);
}

Animation.prototype.doFrame = function(time){
	if(this.running){
	//try{
		if(!time){
		 time = new Date().getTime();
		}
		var offset = time - this.startTime;
		var event;
		var seq;
		var max = this.events.length;
		while((this.eventPointer != max)){
			event = this.events.get(this.eventPointer);
			if(event.time > offset){
				break;
			}
			var len = event.sequences.length;
			for(var i=0;i<len;i++){
				seq = event.sequences[i];
				seq['startTime']=event.time;
				if(!isEmpty(seq.init)){
					seq.init();
				}
				this.activeSequences.push(seq);
				//alert('added seq');
			}
			this.eventPointer++;
		}
		//now iterate active sequences, update them and remove finished ones
		var activelen = this.activeSequences.length;
		var start, val, pct, rval;
		for(var i=0;i<activelen;i++){
			seq = this.activeSequences[i];
			start = seq['startTime'];
			if((start+seq.duration) <= offset){
				//finish the sequence
				if(!isEmpty(seq.handler)){
					seq.handler(seq.end);
				}
				if(!isEmpty(seq.callback)){
					seq.callback();
				}
				seq['lastFrameVal'] = null;
				this.activeSequences.splice(i,1);
				activelen--;
				i--;
				continue;
			}
			
			if(!isEmpty(seq.handler)){
				if(!isEmpty(seq.ease)){
					val = seq.ease((offset-start),seq.start,(seq.end-seq.start),seq.duration)
				}
				else{
					pct = (offset-start)/seq.duration;
					val = ((seq.end-seq.start)*pct) + seq.start;
				}
				if(isEmpty(seq['lastFrameVal']) || isEmpty(seq.min) || (Math.abs(val - seq['lastFrameVal'])>seq.min)){
					rval = seq.handler(val);
					if(typeof rval == 'number'){
						val=rval;
					}
					seq['lastFrameVal']=val;
				}
			}
		}
		
		//finally, continue or stop animation
		if((this.eventPointer == this.events.length) && (activelen==0)){
			this.running = false;
			this.timer=null;
			var callback;
			while((callback = this.callbacks.pop())!=null){
				callback();
			}
			return false;
		}
		else{
			var interval = this.frameinterval;
			if(activelen == 0){
				//don't bother with frames during a period with no active sequences
				interval = this.events.get(this.eventPointer).time-offset;
			}
			this.timer = this.setFrameTimeout(interval);
			return true;
		}
	}
}

Animation.prototype.setFrameTimeout = function(interval){
	if(this.running){
		this.timer = window.setTimeout(this.stepper,interval);
	}
}



function makeDoFrame(animation){
	var animation = animation;
	return function(){
		animation.doFrame();
	}
}

function Sequence(){
	this.start=0;
	this.end=1;
	this.duration;
	//function to handle each intermediate value between start and end
	this.handler;
	//function to be run before the first frame of the sequence is rendered
	this.init;
	//function to be run after the last frame of the sequence is rendered.
	this.callback;
	//easing function from Yahoo library
	this.ease;
	//minimum delta from last render
	this.min;
}

Sequence.prototype.clone = function(){
	var seq = new Sequence();
	seq.start = this.start;
	seq.end = this.end;
	seq.duration = this.duration;
	seq.handler = this.handler;
	return seq;
}

//optional, add reference to an element beneath which to search for the ID
function makeFadeHandler(elementProducer){
	var elementProducer = elementProducer;
	return function(val){
		var el = elementProducer();
		if(el){
			setOpacity(el,val);
			if(el.style.display=="none" || el.style.display==''){
				el.style.display="block";
			}
		}
	}
}

/**
 * AnimationController is used to join disparate animations into one frame cycle
*/
function AnimationController(){
	this.running=false;
	this.events = new SortedSet(new TimedEventComparator());
	this.frameinterval = 5;
	this.lastFrame=0;
	this.currentInterval=0;
	this.stepper = makeDoFrame(this);
	this.timer=null;
}

AnimationController.prototype.animate = function(anim){
	anim.running=true;
	anim.startTime = new Date().getTime();
	var controller = this;
	var an = anim;
	window.setTimeout(function(){controller.push(an,an.startTime);an=null;},1);
}

AnimationController.prototype.cancel = function(anim){
	var len = this.events.length;
	var looking=true;
	for(var i=0;i<len && looking;i++){
		var seqs = this.events.get(i).sequences;
		var slen = seqs.length;
		for(var j=0;j<slen;j++){
			if(seqs[j]==anim){
				seqs.splice(j,1);
				looking=false;
				anim.cancel(true);
				break;
			}
		}
	}
}

AnimationController.prototype.push = function(anim,when){
	if(anim && anim!=null){
		if(!when){
			when = new Date().getTime();
		}
		var ev = new TimedEvent(when);
		var pe = this.events.putIfAbsent(ev);
		if(pe!=null){
			ev = pe;
		}
		ev.sequences.push(anim);
	}
	if(!this.running || (this.currentInterval > this.frameinterval)){
		if(this.timer !=null){
			window.clearTimeout(this.timer);
		}
		this.running=true;
		this.currentInterval=this.frameInterval;
		this.timer=window.setTimeout(this.stepper,this.frameinterval);//this.doFrame();
	}
}


AnimationController.prototype.doFrame = function(){
	if(this.running){
		this.timer=null;
		this.currentInterval=0;
		this.lastFrame = new Date().getTime();
		var event, anims, len, anim;
		var x = 0;
		var max = this.events.length
		while((max > x) && ((event = this.events.get(x)).time <= this.lastFrame)){
			anims = event.sequences;
			len = anims.length;
			for(i=0;i<len;i++){
				anim = anims[i];
				if(anim!=null){
					var offset=-1;
					anim.setFrameTimeout = function(interval){
						if(anim.running){
							offset=interval;
						}
					}
					var cur = new Date().getTime();
					anim.doFrame(cur);
					if(offset>=0){
						//schedule the next frame
						this.push(anim,cur+offset);
					}
					anim=null;
				}
				anims[i]=null;
			}
			x++;
			
		}
		if(x>0){
			this.events.remove(0,x);
		}
		if(this.events.length > 0){
			var cur = new Date().getTime();
			var offset = cur-this.lastFrame;
			var interval = this.frameinterval-offset;
			if(interval < 1){
				interval = 1;
			}
			var next = this.events.get(0).time;
			interval = Math.max(interval,next-cur);
			this.currentInterval = interval;
			this.timer=window.setTimeout(this.stepper,interval);
		}
		else{
			this.running=false;
			this.timer=null;
		}
		
	}
}

masterAnimationController = new AnimationController();/*
TERMS OF USE - EASING EQUATIONS
Open source under the BSD License.
Copyright 2001 Robert Penner All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
 * Neither the name of the author nor the names of contributors may be used to endorse or promote products derived from this software without specific prior written permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * general method signature:
 * @param {Number} t Time value used to compute current value
 * @param {Number} b Starting value
 * @param {Number} c Delta between start and end values
 * @param {Number} d Total length of animation
 * @return {Number} The computed value for the current animation frame
 */

Easing = {
/**
 * Uniform speed between points.
 */
easeNone: function (t, b, c, d) {
	return c*t/d + b;
},

/**
 * Begins slowly and accelerates towards end. (quadratic)
 */
easeIn: function (t, b, c, d) {
	return c*(t/=d)*t + b;
},

/**
 * Begins quickly and decelerates towards end.  (quadratic)
 */
easeOut: function (t, b, c, d) {
	return -c *(t/=d)*(t-2) + b;
},

/**
 * Begins slowly and decelerates towards end. (quadratic)
 */
easeBoth: function (t, b, c, d) {
	if ((t/=d/2) < 1) {
		return c/2*t*t + b;
	}
	
	return -c/2 * ((--t)*(t-2) - 1) + b;
},

/**
 * Begins slowly and accelerates towards end. (quartic)
 */
easeInStrong: function (t, b, c, d) {
	return c*(t/=d)*t*t*t + b;
},

/**
 * Begins quickly and decelerates towards end.  (quartic)
 */
easeOutStrong: function (t, b, c, d) {
	return -c * ((t=t/d-1)*t*t*t - 1) + b;
},

/**
 * Begins slowly and decelerates towards end. (quartic)
 */
easeBothStrong: function (t, b, c, d) {
	if ((t/=d/2) < 1) {
		return c/2*t*t*t*t + b;
	}
	
	return -c/2 * ((t-=2)*t*t*t - 2) + b;
},

/**
 * Snap in elastic effect.
 */

elasticIn: function (t, b, c, d, a, p) {
	if (t == 0) {
		return b;
	}
	if ( (t /= d) == 1 ) {
		return b+c;
	}
	if (!p) {
		p=d*.3;
	}
	
	if (!a || a < Math.abs(c)) {
		a = c; 
		var s = p/4;
	}
	else {
		var s = p/(2*Math.PI) * Math.asin (c/a);
	}
	
	return -(a*Math.pow(2,10*(t-=1)) * Math.sin( (t*d-s)*(2*Math.PI)/p )) + b;
},

/**
 * Snap out elastic effect.
 */
elasticOut: function (t, b, c, d, a, p) {
	if (t == 0) {
		return b;
	}
	if ( (t /= d) == 1 ) {
		return b+c;
	}
	if (!p) {
		p=d*.3;
	}
	
	if (!a || a < Math.abs(c)) {
		a = c;
		var s = p / 4;
	}
	else {
		var s = p/(2*Math.PI) * Math.asin (c/a);
	}
	
	return a*Math.pow(2,-10*t) * Math.sin( (t*d-s)*(2*Math.PI)/p ) + c + b;
},

/**
 * Snap both elastic effect.
 */
elasticBoth: function (t, b, c, d, a, p) {
	if (t == 0) {
		return b;
	}
	
	if ( (t /= d/2) == 2 ) {
		return b+c;
	}
	
	if (!p) {
		p = d*(.3*1.5);
	}
	
	if ( !a || a < Math.abs(c) ) {
		a = c; 
		var s = p/4;
	}
	else {
		var s = p/(2*Math.PI) * Math.asin (c/a);
	}
	
	if (t < 1) {
		return -.5*(a*Math.pow(2,10*(t-=1)) * 
				Math.sin( (t*d-s)*(2*Math.PI)/p )) + b;
	}
	return a*Math.pow(2,-10*(t-=1)) * 
			Math.sin( (t*d-s)*(2*Math.PI)/p )*.5 + c + b;
},


/**
 * Backtracks slightly, then reverses direction and moves to end.
 */
backIn: function (t, b, c, d, s) {
	if (typeof s == 'undefined') {
		s = 1.70158;
	}
	return c*(t/=d)*t*((s+1)*t - s) + b;
},

/**
 * Overshoots end, then reverses and comes back to end.
 */
backOut: function (t, b, c, d, s) {
	if (typeof s == 'undefined') {
		s = 1.70158;
	}
	return c*((t=t/d-1)*t*((s+1)*t + s) + 1) + b;
},

/**
 * Backtracks slightly, then reverses direction, overshoots end, 
 * then reverses and comes back to end.
 */
backBoth: function (t, b, c, d, s) {
	if (typeof s == 'undefined') {
		s = 1.70158; 
	}
	
	if ((t /= d/2 ) < 1) {
		return c/2*(t*t*(((s*=(1.525))+1)*t - s)) + b;
	}
	return c/2*((t-=2)*t*(((s*=(1.525))+1)*t + s) + 2) + b;
},

/**
 * Bounce off of start.
 */
bounceIn: function (t, b, c, d) {
	return c - YAHOO.util.Easing.bounceOut(d-t, 0, c, d) + b;
},

/**
 * Bounces off end.
 */
bounceOut: function (t, b, c, d) {
	if ((t/=d) < (1/2.75)) {
		return c*(7.5625*t*t) + b;
	} else if (t < (2/2.75)) {
		return c*(7.5625*(t-=(1.5/2.75))*t + .75) + b;
	} else if (t < (2.5/2.75)) {
		return c*(7.5625*(t-=(2.25/2.75))*t + .9375) + b;
	}
	return c*(7.5625*(t-=(2.625/2.75))*t + .984375) + b;
},

/**
 * Bounces off start and end.
 */
bounceBoth: function (t, b, c, d) {
	if (t < d/2) {
		return YAHOO.util.Easing.bounceIn(t*2, 0, c, d) * .5 + b;
	}
	return YAHOO.util.Easing.bounceOut(t*2-d, 0, c, d) * .5 + c*.5 + b;
}
};
/**
 * Tooltip animation support
 * author: Alex Vigdor     copyright 2007 ABCNews Internet Ventures
 **/
var allTooltipsOnPage = new Object();
var ttLastEl;
var reset=true;
var defaultTTAnimDuration = 3000;
var defaultTooltipCSSClass = "tooltip";
var ttSync=false;

var ttCont = document.createElement('div');
ttCont.style.position="absolute";
ttCont.style.visibility="hidden";
ttCont.style.zIndex = "-1";
//ttCont.className = "tooltip";
addOnload(function(){getBodyElement().appendChild(ttCont)});

var ttFadeH=function(val){
	if(val==0.9){
		unhideTooltip();
	}
	else if(val==0){
		hideTooltip();
	}
};//makeFadeHandler(function(){return ttCont;});
var ttAnIn = new Animation();
var ttZ = new Sequence();
ttZ.init = function(){
	if(reset){
		//setOpacity(ttCont,0);
	}
}
var ttFi = new Sequence();
ttFi.duration = 20;
ttFi.end=0.9;
ttFi.init = function(){
	document.onmousemove=null;
	if(window.lastTTabsTop!=null){
		updatePosition(window.lastTTabsTop,window.lastTTabsLeft);
	}
	
	//ttFi.start = getOpacity(ttCont);
};
ttFi.handler = ttFadeH;
var ttFo = new Sequence();
ttFo.duration = 20;
ttFo.start=0.9;
ttFo.end=0;
ttFo.handler = ttFadeH;
ttFo.init=function(){
	//ttFo.start = getOpacity(ttCont);
}

var ttAnOut = new Animation();
var ttFoc = ttFo.clone();
ttFoc.init=function(){
	//ttFoc.start = getOpacity(ttCont);
}
ttFoc.callback= function(){
	ttLastEl=null;
	document.onmousemove=null;
	hideTooltip();
}
ttAnOut.addSequence(150,ttFoc);

function createTTAnIn(duration, delay){
	ttAnIn = new Animation();
	ttAnIn.addSequence(0,ttZ);
	if(typeof delay == 'undefined') {
		delay = 300;
	}
	
	ttAnIn.addSequence(delay,ttFi);
	ttAnIn.addSequence(duration,ttFo);
}

function hideTooltip(){
	ttCont.style.visibility="hidden";
	ttCont.style.zIndex = "-1";
	ttCont.style.display="none";
}

function unhideTooltip(){
	ttCont.style.visibility="visible";
	ttCont.style.zIndex = "20000";
	ttCont.style.display="block";
}

function getTooltip(text,className){
	var textClass = className+text;
	if(!allTooltipsOnPage[textClass]){
		allTooltipsOnPage[textClass] = new TooltipImpl(text,className);
	}
	return allTooltipsOnPage[textClass];
}

function moveTT(evt){
if(!evt) var evt=event;
window.lastTTabsTop = absTop(evt);
window.lastTTabsLeft = absLeft(evt);
}

function updatePosition(absTop,absLeft){
	var minx = 0;
	var miny=0;
	var body = getBodyElement();
	var maxx = body.offsetWidth;
	var maxy = body.offsetHeight;
	ttCont.style.display="block";
	var width = ttCont.offsetWidth;
	var height = ttCont.offsetHeight;
	ttCont.style.display="none";
	var left = absLeft;
	var top = absTop+20;
	var pane = findPane(ttLastEl);
	if(!isEmpty(pane)){
		minx = calcPosition(pane.viewport,"Left");
		miny = calcPosition(pane.viewport,"Top");
		maxx = minx+pane.viewport.offsetWidth;
		maxy = miny+pane.viewport.offsetHeight;
	}
	if(left <minx){
		left = minx;
	}
	else if((left+width)>maxx){
		left = left-width;
		if(left < minx){
			left = maxx - width;
		}
	}	
	if(top<miny){
		top = miny;
	}
	else if((top+height)>maxy){
		top = absTop - height - 15;
		if(top < miny){
			top=miny;
		}
	}
	ttCont.style.left = left+"px";
	ttCont.style.top = top+"px";
}

function tooltip(event,element,text){
	customTooltip(event,element,text,defaultTooltipCSSClass,defaultTTAnimDuration);
}

function customTooltip(event,element,text,className,duration, delay){
	if(!ttSync){
		ttSync=true;
		try{
	var tooltip = getTooltip(text,className);
	
	if(element !=null && ttLastEl == element){
		reset=false;
	}
	else{
		reset=true;
	}
	ttAnIn.cancel();
	ttAnIn.reset();
	ttAnOut.cancel();
	ttLastEl = element;
	if(element != null){
		element.onmouseout = cancelTooltip;
	}
	if(reset){
		while(ttCont.firstChild != null){
			ttCont.removeChild(ttCont.firstChild);
		}
		ttCont.appendChild(tooltip.div);
		window.lastTTabsTop = null;
		window.lastTTabsLeft = null;
		updatePosition(absTop(event),absLeft(event));
		document.onmousemove = moveTT;
	}
	
	createTTAnIn(duration, delay);
	ttAnIn.run();
	}
	finally{
		ttSync=false;
	}
	}
}

function cancelTooltip(event){
	if(!ttSync){
		ttSync=true;
		try{
	if(ttLastEl != null){
		ttLastEl.onmouseout = null;
	}
	ttAnIn.cancel();
	ttAnOut.reset();
	ttAnOut.run();
	}
	finally{
		ttSync=false;
	}
	}
}

function TooltipImpl(text,className){
	this.text = text;
	this.div = document.createElement('div');
	this.div.className = className;
	this.div.innerHTML= text;
}
/**
 * Ticker animation support
 * author: Alex Vigdor     copyright 2007 ABCNews Internet Ventures
 **/
var tickerEl = null;
var tickerAnim = new Animation();
var tickerSeq = new Sequence();
var tickerHeadline;
tickerSeq.start=0;
tickerSeq.min=0.5;
tickerSeq.handler = function(val){
	val = Math.round(val);
	tickerEl.innerHTML = tickerHeadline.substring(0,val);
	return val;
}
tickerSeq.callback = function(){
	tickerEl.innerHTML = tickerHeadline;
}
tickerAnim.addSequence(600,tickerSeq);

function tickerOver(show){
	if(window.tickerPl){
		window.tickerPl.gotoItem(show,'skip');
		window.tickerPl.pause();
	}
}

function pauseTickerPl(){
if(window.tickerPl){
	window.tickerPl.pause();
}
}

function resumeTickerPl(){
if(window.tickerPl){
	window.tickerPl.resume();
}
}

function tickerKey(evt){
	if(!evt) var evt = event;
	if(evt.keyCode==40){
		var el = document.getElementById('show-ticker');
		var as = el.getElementsByTagName('a');
		if(as.length > 0){
			as.item(0).focus();
		}
		stopEvent(evt);
		return false;
	}
	else if(evt.keyCode==38){
		var actives = getElementsWithAttribute(document.getElementById('shownav'),'class','showNavActive');
		if(actives.length > 0){
			actives[0].parentNode.focus();
		}
		stopEvent(evt);
		return false;
	}
}

function ticker(headline,url,skip){
	if(masterAnimationController){
		masterAnimationController.cancel(tickerAnim);
	}
	else{
		tickerAnim.cancel(true);
	}
	tickerSeq.end=headline.length;
	tickerSeq.duration = 107 * headline.length;
	tickerHeadline=headline;
	
	tickerAnim.reset();
	var el = document.getElementById("show-ticker");
	while(!isEmpty(el.firstChild)){
		el.firstChild.omnouseover=null;
		el.firstChild.onmouseout=null;
		el.firstChild.onkeydown=null;
		el.removeChild(el.firstChild);
	}
	var ela = document.createElement("a");
	ela.setAttribute("href",url);
	ela.onmouseover=pauseTickerPl;
	ela.onmouseout=resumeTickerPl;
	ela.onkeydown = tickerKey;
	ela.className="tickertext";
	tickerEl = ela;
	el.appendChild(ela);
	if(skip){
		tickerSeq.callback();
	}
	else{
		if(masterAnimationController){
			masterAnimationController.animate(tickerAnim);
		}
		else{
			tickerAnim.run();
		}
	}
}	

function TickerItem(show,headline,url){
	this.id=show;
	this.headline= headline;
	this.url = url;
}
TickerItem.prototype.activate = function(args){
	var skip = (args && (args.length > 0) && (args[0] == 'skip'));
	ticker(this.headline,this.url,skip);
	document.getElementById('show'+this.id).className="showNavActive";
}
TickerItem.prototype.deactivate = function(){
	var el = document.getElementById('show'+this.id);
	el.className="showNavinActive";
}/**
 * Functions for the story page
 * author: Max Weng      copyright 2007 ABCNews Internet Ventures
 **/
function setStoryTextFont(size) {
	var img = document.getElementsByTagName('img');
	if (size == 'small') {
			for (i=0; i<img.length; i++) {
				var className = img[i].className;
				if (className == 'font_sm') {
					img[i].src = base_url+'/images/font-sm_on2.gif';
				} else if (className == 'font_md') {
					img[i].src = base_url+'/images/font-md_off2.gif';
				} else if (className == 'font_lg') {
					img[i].src = base_url+'/images/font-lg_off2.gif';
				}
			}
			document.getElementById('storyText').className='storyTextSm';
	} else if (size == 'large') {
			for (i=0; i<img.length; i++) {
				var className = img[i].className;
				if (className == 'font_sm') {
					img[i].src = base_url+'/images/font-sm_off2.gif';
				} else if (className == 'font_md') {
					img[i].src = base_url+'/images/font-md_off2.gif';
				} else if (className == 'font_lg') {
					img[i].src = base_url+'/images/font-lg_on2.gif';
				}
			}
			document.getElementById('storyText').className='storyTextLg';
	} else { // default to be the medium size
			for (i=0; i<img.length; i++) {
				var className = img[i].className;
				if (className == 'font_sm') {
					img[i].src = base_url+'/images/font-sm_off2.gif';
				} else if (className == 'font_md') {
					img[i].src = base_url+'/images/font-md_on2.gif';
				} else if (className == 'font_lg') {
					img[i].src = base_url+'/images/font-lg_off2.gif';
				}
			}
			document.getElementById('storyText').className='storyTextMd';
	}
		
	
}

function changeStoryTextFont(size) {
        if (size) {
                // set the CSS style
                setStoryTextFont(size);
                // save to the cookie, for 180 days
                createCookie("fontSize", size, 4641);
        }
}
function setCaption(state) {
	if (state == 'open') {
		var short = document.getElementById("cap-short");
		var full = document.getElementById("cap-full");
		
		short.style.display = 'none';
		full.style.display = 'block';
		
	} else if (state == 'close') {
		var short = document.getElementById("cap-short");
		var full = document.getElementById("cap-full");
		
		short.style.display = 'block';
		full.style.display = 'none';
	}
}
/*
 * widgetCarousel.js
 *
 * A utility for generating the components of a widget carousel
 * Returns a UrlPlaylistManager that can be used to populate the carousel playlist and gain
 * access to playlist controls
 */
 
 function createCarouselPane(manager,width){
	var list = manager.playlist;
	var pane = new Pane(list.id);
	pane.addMouseOver(function(){pane.engage()});
	pane.addMouseOut(function(){pane.disengage()});
	pane.addEngage(function(){list.pause()});
	pane.addDisengage(function(){list.resume()});
	manager.pane=pane;
	
	var leftAnim = new Animation();

	//old moving left
	var leftOldSlide = new Sequence();
	leftOldSlide.start = 0;
	leftOldSlide.end = -width;
	leftOldSlide.duration = 1000;
	leftOldSlide.min=0.5;
	leftOldSlide.ease = Easing['easeBothStrong'];
	leftOldSlide.callback = function(){
		if(pane.oldContent){
			pane.oldContent.style.left = "-"+width+"px";
		}
	};
	leftOldSlide.handler = function(val){
		val = Math.round(val);
		if(pane.oldContent){
			pane.oldContent.style.left = val+"px";
		}
		return val;
	};
	leftAnim.addSequence(0,leftOldSlide);

	//new moving left
	var leftNewSlide = new Sequence();
	leftNewSlide.start = width;
	leftNewSlide.end = 0;
	leftNewSlide.duration = 1000;
	leftNewSlide.min=0.5;
	leftNewSlide.ease = Easing['easeBothStrong'];
	leftNewSlide.init = function(){
		if(pane.content){
			pane.content.style.left=width+"px";
		}	
		if(pane.content && pane.content.parentNode != pane.viewport){
			pane.viewport.appendChild(pane.content);
		};
	};
	leftNewSlide.handler = function(val){
		val = Math.round(val);
		pane.content.style.left = val+"px";
		return val;
	};
	leftNewSlide.callback = function(){
		pane.content.style.left = "0px";
	}
	leftAnim.addSequence(0,leftNewSlide);

	var rightAnim = new Animation();

	//old moving right
	var rightOldSlide = new Sequence();
	rightOldSlide.start = 0;
	rightOldSlide.end = width ;
	rightOldSlide.duration = 1000;
	rightOldSlide.min=0.5;
	rightOldSlide.ease = Easing['easeBothStrong'];
	rightOldSlide.handler = function(val){
		val = Math.round(val);
		if(pane.oldContent){
			pane.oldContent.style.left = val+"px";
		}
		return val;
	};
	rightOldSlide.callback = function(){
		if(pane.oldContent){
			pane.oldContent.style.left = width+"px";
		}
	};
	rightAnim.addSequence(0,rightOldSlide);

	//new moving right
	var rightNewSlide = new Sequence();
	rightNewSlide.start = -width;
	rightNewSlide.end = 0;
	rightNewSlide.duration = 1000;
	rightNewSlide.min=0.5;
	rightNewSlide.ease = Easing['easeBothStrong'];
	rightNewSlide.init = function(){
		if(pane.content){
			pane.content.style.left="-"+width+"px";
		}	
		if(pane.content && pane.content.parentNode != pane.viewport){
			pane.viewport.appendChild(pane.content);
		};
	};
	rightNewSlide.handler = function(val){
		val = Math.round(val);
		pane.content.style.left = val+"px";
		return val;
	};
	rightNewSlide.callback = function(){
		pane.content.style.left = "0px";
	}
	rightAnim.addSequence(0,rightNewSlide);
	
	pane['leftAnim']=leftAnim;
	pane['rightAnim']=rightAnim;
	pane['quickAnim']=new Animation();
	return pane;
 }
 
 function createCarouselManager(id){
	var list = new Playlist(id);
	//list.setPreload(true);
	var manager = new UrlPlaylistManager(list);
	return manager;
 }/**
 * SWFObject v1.5: Flash Player detection and embed - http://blog.deconcept.com/swfobject/
 *
 * SWFObject is (c) 2007 Geoff Stearns and is released under the MIT License:
 * http://www.opensource.org/licenses/mit-license.php
 *
 */
if(typeof deconcept=="undefined"){var deconcept=new Object();}if(typeof deconcept.util=="undefined"){deconcept.util=new Object();}if(typeof deconcept.SWFObjectUtil=="undefined"){deconcept.SWFObjectUtil=new Object();}deconcept.SWFObject=function(_1,id,w,h,_5,c,_7,_8,_9,_a){if(!document.getElementById){return;}this.DETECT_KEY=_a?_a:"detectflash";this.skipDetect=deconcept.util.getRequestParameter(this.DETECT_KEY);this.params=new Object();this.variables=new Object();this.attributes=new Array();if(_1){this.setAttribute("swf",_1);}if(id){this.setAttribute("id",id);}if(w){this.setAttribute("width",w);}if(h){this.setAttribute("height",h);}if(_5){this.setAttribute("version",new deconcept.PlayerVersion(_5.toString().split(".")));}this.installedVer=deconcept.SWFObjectUtil.getPlayerVersion();if(!window.opera&&document.all&&this.installedVer.major>7){deconcept.SWFObject.doPrepUnload=true;}if(c){this.addParam("bgcolor",c);}var q=_7?_7:"high";this.addParam("quality",q);this.setAttribute("useExpressInstall",false);this.setAttribute("doExpressInstall",false);var _c=(_8)?_8:window.location;this.setAttribute("xiRedirectUrl",_c);this.setAttribute("redirectUrl","");if(_9){this.setAttribute("redirectUrl",_9);}};deconcept.SWFObject.prototype={useExpressInstall:function(_d){this.xiSWFPath=!_d?"expressinstall.swf":_d;this.setAttribute("useExpressInstall",true);},setAttribute:function(_e,_f){this.attributes[_e]=_f;},getAttribute:function(_10){return this.attributes[_10];},addParam:function(_11,_12){this.params[_11]=_12;},getParams:function(){return this.params;},addVariable:function(_13,_14){this.variables[_13]=_14;},getVariable:function(_15){return this.variables[_15];},getVariables:function(){return this.variables;},getVariablePairs:function(){var _16=new Array();var key;var _18=this.getVariables();for(key in _18){_16[_16.length]=key+"="+_18[key];}return _16;},getSWFHTML:function(){var _19="";if(navigator.plugins&&navigator.mimeTypes&&navigator.mimeTypes.length){if(this.getAttribute("doExpressInstall")){this.addVariable("MMplayerType","PlugIn");this.setAttribute("swf",this.xiSWFPath);}_19="<embed type=\"application/x-shockwave-flash\" src=\""+this.getAttribute("swf")+"\" width=\""+this.getAttribute("width")+"\" height=\""+this.getAttribute("height")+"\" style=\""+this.getAttribute("style")+"\"";_19+=" id=\""+this.getAttribute("id")+"\" name=\""+this.getAttribute("id")+"\" ";var _1a=this.getParams();for(var key in _1a){_19+=[key]+"=\""+_1a[key]+"\" ";}var _1c=this.getVariablePairs().join("&");if(_1c.length>0){_19+="flashvars=\""+_1c+"\"";}_19+="/>";}else{if(this.getAttribute("doExpressInstall")){this.addVariable("MMplayerType","ActiveX");this.setAttribute("swf",this.xiSWFPath);}_19="<object id=\""+this.getAttribute("id")+"\" classid=\"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000\" width=\""+this.getAttribute("width")+"\" height=\""+this.getAttribute("height")+"\" style=\""+this.getAttribute("style")+"\">";_19+="<param name=\"movie\" value=\""+this.getAttribute("swf")+"\" />";var _1d=this.getParams();for(var key in _1d){_19+="<param name=\""+key+"\" value=\""+_1d[key]+"\" />";}var _1f=this.getVariablePairs().join("&");if(_1f.length>0){_19+="<param name=\"flashvars\" value=\""+_1f+"\" />";}_19+="</object>";}return _19;},write:function(_20){if(this.getAttribute("useExpressInstall")){var _21=new deconcept.PlayerVersion([6,0,65]);if(this.installedVer.versionIsValid(_21)&&!this.installedVer.versionIsValid(this.getAttribute("version"))){this.setAttribute("doExpressInstall",true);this.addVariable("MMredirectURL",escape(this.getAttribute("xiRedirectUrl")));document.title=document.title.slice(0,47)+" - Flash Player Installation";this.addVariable("MMdoctitle",document.title);}}if(this.skipDetect||this.getAttribute("doExpressInstall")||this.installedVer.versionIsValid(this.getAttribute("version"))){var n=(typeof _20=="string")?document.getElementById(_20):_20;n.innerHTML=this.getSWFHTML();return true;}else{if(this.getAttribute("redirectUrl")!=""){document.location.replace(this.getAttribute("redirectUrl"));}}return false;}};deconcept.SWFObjectUtil.getPlayerVersion=function(){var _23=new deconcept.PlayerVersion([0,0,0]);if(navigator.plugins&&navigator.mimeTypes.length){var x=navigator.plugins["Shockwave Flash"];if(x&&x.description){_23=new deconcept.PlayerVersion(x.description.replace(/([a-zA-Z]|\s)+/,"").replace(/(\s+r|\s+b[0-9]+)/,".").split("."));}}else{if(navigator.userAgent&&navigator.userAgent.indexOf("Windows CE")>=0){var axo=1;var _26=3;while(axo){try{_26++;axo=new ActiveXObject("ShockwaveFlash.ShockwaveFlash."+_26);_23=new deconcept.PlayerVersion([_26,0,0]);}catch(e){axo=null;}}}else{try{var axo=new ActiveXObject("ShockwaveFlash.ShockwaveFlash.7");}catch(e){try{var axo=new ActiveXObject("ShockwaveFlash.ShockwaveFlash.6");_23=new deconcept.PlayerVersion([6,0,21]);axo.AllowScriptAccess="always";}catch(e){if(_23.major==6){return _23;}}try{axo=new ActiveXObject("ShockwaveFlash.ShockwaveFlash");}catch(e){}}if(axo!=null){_23=new deconcept.PlayerVersion(axo.GetVariable("$version").split(" ")[1].split(","));}}}return _23;};deconcept.PlayerVersion=function(_29){this.major=_29[0]!=null?parseInt(_29[0]):0;this.minor=_29[1]!=null?parseInt(_29[1]):0;this.rev=_29[2]!=null?parseInt(_29[2]):0;};deconcept.PlayerVersion.prototype.versionIsValid=function(fv){if(this.major<fv.major){return false;}if(this.major>fv.major){return true;}if(this.minor<fv.minor){return false;}if(this.minor>fv.minor){return true;}if(this.rev<fv.rev){return false;}return true;};deconcept.util={getRequestParameter:function(_2b){var q=document.location.search||document.location.hash;if(_2b==null){return q;}if(q){var _2d=q.substring(1).split("&");for(var i=0;i<_2d.length;i++){if(_2d[i].substring(0,_2d[i].indexOf("="))==_2b){return _2d[i].substring((_2d[i].indexOf("=")+1));}}}return "";}};deconcept.SWFObjectUtil.cleanupSWFs=function(){var _2f=document.getElementsByTagName("OBJECT");for(var i=_2f.length-1;i>=0;i--){_2f[i].style.display="none";for(var x in _2f[i]){if(typeof _2f[i][x]=="function"){_2f[i][x]=function(){};}}}};if(deconcept.SWFObject.doPrepUnload){if(!deconcept.unloadSet){deconcept.SWFObjectUtil.prepUnload=function(){__flash_unloadHandler=function(){};__flash_savedUnloadHandler=function(){};window.attachEvent("onunload",deconcept.SWFObjectUtil.cleanupSWFs);};window.attachEvent("onbeforeunload",deconcept.SWFObjectUtil.prepUnload);deconcept.unloadSet=true;}}if(!document.getElementById&&document.all){document.getElementById=function(id){return document.all[id];};}var getQueryParamValue=deconcept.util.getRequestParameter;var FlashObject=deconcept.SWFObject;var SWFObject=deconcept.SWFObject;/**
 * show page js
 **/
 
isIE = false;
if(typeof document.all!="undefined"){ if(typeof document.getElementById!="undefined"){ if(navigator.userAgent.toLowerCase().indexOf("msie 6")!=-1){ isIE = true; }}}
 
 function capTop(show, dim, bg) {
	capImgPng = 'http://a.abcnews.com/assets/images/shows/'+show+'/'+show+'_'+dim+'_'+bg+'.png'
	capImgSrc = '';
	capImg = (isIE)?'http://a.abcnews.com/images/site/vortex/spacer.gif' : capImgPng;
	imgSrcCapFilter = (isIE)?' style="filter:progid:DXImageTransform.Microsoft.AlphaImageLoader(src='+capImgPng+', sizingMethod=scale); position:absolute;top:0px;left:0px;" ' : ' style="position:absolute;top:0px;left:0px;"';
	capImgSrc += '<img src="'+capImg+'" ';
	capImgSrc += imgSrcCapFilter;
	capImgSrc += ' alt="" width="'+dim+'" height="4" border="0">';
	document.write(capImgSrc);
}

//for tooltip flyouts
function preview(event, element, url, setclass, timer, delay) {
	var ev = cloneEvent(event);
	var elem = element;
	var del = delay;
	
	getMarkup(url,-1,function(markup){
		try{
			customTooltip(ev, elem, markup.markup, setclass, timer, del);
		}
		catch(e){
			alert(e.name+": "+e.message);
		}
	});
}

function cloneEvent(event){
	var newEvent = new Object();
	newEvent['pageX'] = event['pageX'];
	newEvent['pageY'] = event['pageY'];
	newEvent['clientX'] = event['clientX'];
	newEvent['clientY'] = event['clientY'];
	return newEvent;
}

function ihopHover (state, divId, type) {
	if (state) {
		document.getElementById(divId).className = "ihop-active" + type;
	} else {
		document.getElementById(divId).className = "ihop-activeOff";
	}
}

/********************************************
		overlay
********************************************/
window.currentOverlay = '';

function overlayDiv() {
	this.className = 'div.overlayPane';
	this.anchor;
	this.div;
	this.objName;
	this.anchorText;
	
	this.ready = function() {
		this.anchorText = $(this.anchor + "> span > a").html();
		$(this.anchor).html('<span><a href="#" onclick="'+this.objName+'.show();return false;">'+this.anchorText+'</a></span>');
	}
	
	this.show = function (){
		if (window.currentOverlay != '') {
			closeOverlay = eval(window.currentOverlay.replace('div#','') + 'Obj');
			closeOverlay.close();
		}
		$(this.div).show('fast',this.position()).focus();
		$(this.anchor).html('<span><a href="#" onclick="'+this.objName+'.close();return false;">'+this.anchorText+'</a></span>');
		$(this.anchor + "> span > a").css('background-position', 'right -412px');
		window.currentOverlay = this.div;

	}
	
	this.close = function() {
		$(this.div).hide();
		$(this.anchor).html('<span><a href="#" onclick="'+this.objName+'.show();return false;">'+this.anchorText+'</a></span>');
		$(this.anchor + "> span > a").css('background-position', 'right -394px');
	}
	
	this.position = function() {
		var top = 0;
		var left = 0;
		var midpoint = $(window).width()/2;
	
		if (this.anchor != null) { //anchor overlay
			top = $(this.anchor).offset().top + $(this.anchor).outerHeight();
			
			var overlayBottom = top + $(this.div).height();
			var screenBottom = $(window).scrollTop() + $(window).height();

			if (overlayBottom > screenBottom) { //display above anchor
				top = $(this.anchor).offset().top - $(this.div).height();
				top += 2;
			} 
			
			if ($(this.anchor).offset().left < midpoint) {
				left = $(this.anchor).offset().left;
			} else {
				left = ($(this.anchor).offset().left + $(this.anchor).outerWidth())- $(this.div).width();
			}
			
		} else { //center on page
			top = $(window).scrollTop();
			left = midpoint - ($(this.div).width()/2);
			
			if ($(this.div).height() < $(window).height()) {
				top = top + ($(window).height()/2) - ($(this.div).height()/2);
			} else {
				top = top + 20;
			}
		}
		
		//top += -3;
		if ($.browser.mozilla) {
			left += 2;
		}
		
		$(this.div).css({'top':top + 'px','left':left + 'px'});
	}
}



$(document).ready(function() {
	$('div.overlayPane').appendTo('body');
	$('div.overlayPane').hide();
});








var addthis_pub = "abcnews";
var addthis_options = 'favorites, buzz, delicious, fark, google, linkedin, live, mixx, myspace, newsvine, technorati, yahoobkm, more';
var addthis_exclude = 'print';

abcNewsShare = new Object();
abcNewsShare.url = null;
abcNewsShare.tools = {
	sites:[
		{
		name:'Email',
		titlep:'title',
		alt:'Email to Friend',
		addthis:'email'
		},
		{
		name:'Twitter',
		titlep:'title',
		alt:'Let your followers know what you are currently reading',
		addthis:'twitter'
		},
		{
		name:'Facebook',
		titlep:'t',
		alt:'Share this with friends on Facebook',
		addthis:'facebook'
		},
		{
		name:'Digg',
		titlep:'title',
		alt:'Digg this story',
		addthis:'digg'
		},
		{
		name:'Buzz',
		titlep:'title',
		alt:'Submit to Yahoo! Buzz',
		addthis:'buzz'
		},
		{
		name:'StumbleUpon',
		titlep:'title',
		alt:'StumbleUpon this story',
		addthis:'stumbleupon'
		}
		
	]
}
abcNewsShare.moretools = {
	sites:[
		{
		name:'Fark',
		titlep:'title',
		alt:'Fark',
		addthis:'fark'
		}, 
		{
		name:'Technorati',
		titlep:'title',
		alt:'Technorati',
		addthis:'technorati'
		},
		{
		name:'Google',
		titlep:'title',
		alt:'Google',
		addthis:'google'
		}, 
		{
		name:'Live',
		titlep:'title',
		alt:'Live',
		addthis:'live'
		}, 
		{
		name:'My Space',
		titlep:'title',
		alt:'My Space',
		addthis:'myspace'
		},
		{
		name:'Newsvine',
		titlep:'title',
		alt:'Newsvine',
		addthis:'newsvine'
		},
		{
		name:'Reddit',
		titlep:'headline',
		alt:'Share on Reddit',
		addthis:'reddit'
		}, 
		{
		name:'Delicious',
		titlep:'title',
		alt:'Delicious',
		addthis:'delicious'
		}, 
		{
		name:'Mixx',
		titlep:'title',
		alt:'Mixx',
		addthis:'mixx'
		},
		{
		name:'Yahoo',
		titlep:'title',
		alt:'Yahoo',
		addthis:'yahoobkm'
		}
	]
};

abcNewsShare.permissions = {
	'rail': {
		'print':false,
		'rss':false,
		'font':false,
		'labels':0,
		'rowOne':abcNewsShare.moretools.sites.length,
		'rowTwo':0,
		'rowLabel':false
	},
	'blog entry': {
		'print':true,
		'rss':true,
		'font':false,
		'labels':1,
		'rowOne':5,
		'rowTwo':5,
		'rowLabel':true
	},
	'recipe': {
		'print':true,
		'rss':false,
		'font':true,
		'labels':1,
		'rowOne':9,
		'rowTwo':1,
		'rowLabel':true
	},
	'video': {
		'print':false,
		'rss':false,
		'font':false,
		'labels':abcNewsShare.tools.sites.length,
		'rowOne':9,
		'rowTwo':1,
		'rowLabel':true
	},
	'mailform': {
		'print':false,
		'rss':false,
		'font':false,
		'labels':abcNewsShare.tools.sites.length,
		'rowOne':9,
		'rowTwo':1,
		'rowLabel':true
	},
	'slideshow': {
		'print':true,
		'rss':false,
		'font':false,
		'labels':abcNewsShare.tools.sites.length,
		'rowOne':9,
		'rowTwo':1,
		'rowLabel':true
	},
	'comments': {
		'print':true,
		'rss':false,
		'font':false,
		'labels':abcNewsShare.tools.sites.length,
		'rowOne':9,
		'rowTwo':1,
		'rowLabel':true
	},
	'story': {
		'print':true,
		'rss':true,
		'font':true,
		'labels':3,
		'rowOne':9,
		'rowTwo':1,
		'rowLabel':true
	}
};

abcNewsShare.instances = 1;	
abcNewsShare.rowOne = 8;
abcNewsShare.rowTwo = 2;
abcNewsShare.shareLabels = 3;
abcNewsShare.rowLabel = true;
abcNewsShare.print = true;
abcNewsShare.font = true;
abcNewsShare.rss = true;

abcNewsShare.state = new Object();
function diggIt(url, title){
	window.open('http://digg.com/submit?url='+url+'&title='+title)
}


function tools(moreOptionDiv, moreDiv) {
	if (abcNewsShare.state[moreOptionDiv] == true) {
		document.getElementById(moreOptionDiv).className = 'toolbar-more';
		document.getElementById(moreOptionDiv).innerHTML = 'More';
		document.getElementById(moreDiv).style.display = 'none';
		abcNewsShare.state[moreOptionDiv] = false;
	} else {
		document.getElementById(moreOptionDiv).className = 'toolbar-more-on';
		document.getElementById(moreOptionDiv).innerHTML = 'Close';
		document.getElementById(moreDiv).style.display = 'block';
		abcNewsShare.state[moreOptionDiv] = true;
	}
}

imgBase = 'http://a.abcnews.go.com/assets/images';
newsLabel = ['Share this story with friends','Break news in your social network!','Make headlines...for your friends.'];

abcNewsShare.addThis = function(obj,url,title){
	addthis_title = title; addthis_url = url;
}

abcNewsShare.render = function(index,url,title,rss,id,email,font,sp){

	var toolboxDiv = 'toolboxDiv';
	var moreOptionDiv = 'moreOptionDiv';
	var moreDiv = 'moreDiv'

	toolboxDiv = toolboxDiv + this.instances;
	moreOptionDiv = moreOptionDiv + this.instances;
	moreDiv = moreDiv + this.instances;
	this.instances += 1;
	
	if (this.permissions[sp] != undefined) {
		this.rowOne = this.permissions[sp].rowOne;
		this.rowRow = this.permissions[sp].rowTwo;
		this.shareLabels = this.permissions[sp].labels;
		this.rowLabel = this.permissions[sp].rowLabel;
		this.print = this.permissions[sp].print;
		this.font = this.permissions[sp].font;
		this.rss = this.permissions[sp].rss;
	}
	
	if(window.name != 'print'){
	var canonicalObj = document.getElementById('canonical');
	var canonical = ((canonicalObj!=null)&&(canonicalObj!=false))?canonicalObj.href:false;
	this.urlValTmp = window.location +'';
	if((canonical)&&(!abcNewsShare.canonicalOverride)) {
		this.urlValTmp = canonical;
	} else if(url) {
		this.urlValTmp = url+''; 
	} 
	
	this.urlValTmp = this.urlValTmp.replace(/[?&]page=\d+/,'');
	this.urlVal = encodeURIComponent(this.urlValTmp);
	this.titleVal = title?title:document.title;
	//this.titleVal = escape(this.titleVal);
	addthis_title = this.titleVal; addthis_url = this.urlVal;
	
	document.write('<div class="toolbox" id="'+toolboxDiv+'">');
		document.write('<div class="wrapper misc">');
		if (this.print) {
			if(id){
				if(sp=='recipe'){
					document.write('<a href="recipePrint?id='+id+'&format=fullpage" target="_blank" class="print-more">Print Full Page</a><span>|</span><a href="recipePrint?id='+id+'&format=3x5" target="_blank">3x5</a><span>|</span><a href="recipePrint?id='+id+'&format=4x6" target="_blank">4x6</a>');
				}else{
					//document.write('<a href="/print?id='+id+'" target="_blank" class="print">Print</a>');
					document.write('<a class="print" href="#" onclick="FDCPUrl(\'http:/\/abcnews.go.com/print?id='+id+'\', true); return false;">Print</a>');
				}
			}else{
				document.write('<a href="javascript:window.print();" class="print">Print</a>');
			}

		}
		if(this.rss){
			document.write('<a href="'+rss+'" target="_blank" class="rss">RSS</a>');
		}
		document.write('<div class="clearboth"><!--empty--></div></div>');
		if (this.font) {
			document.write('<div class="wrapper font">');
			document.write('<div class="label">Font Size:</div>');
			document.write('<a href="javascript:void(0);" onclick="changeStoryTextFont(\'small\'); return false;" class="font-small"><span><img id="font_sm" class="font_sm" src="'+imgBase+'/font-sm_off2.gif" alt="" border="0"/></span></a> <a href="javascript:void(0);" onclick="changeStoryTextFont(\'medium\'); return false;" class="font-medium"><span><img id="font_md" class="font_md" src="'+imgBase+'/font-md_off2.gif" alt="" border="0"/></span></a> <a href="javascript:void(0);" onclick="changeStoryTextFont(\'large\'); return false;" class="font-large"><span><img id="font_lg" class="font_lg" src="'+imgBase+'/font-lg_off2.gif" alt="" border="0"/></span></a>');
			document.write('<div class="clearboth"><!--empty--></div>');
			document.write('</div>');
		}
		document.write('<div class="wrapper share">');
		document.write('<div class="label">Share:</div>');
		for(i=0;i<abcNewsShare.tools.sites.length;i++){
			this.divTmp = '';
			this.obj = abcNewsShare.tools.sites[i];
			if (i == this.shareLabels && this.shareLabels < abcNewsShare.tools.sites.length) this.divTmp = this.divTmp + '<div>';
			if (i > this.shareLabels-1) {
				this.divTmp = this.divTmp + '<a class="addthis_button_'+this.obj.addthis+'" title="'+this.obj.alt+'" name="lpos=share['+this.obj.name+']&lid=link[]"></a>';
			} else {
				this.divTmp = this.divTmp + '<a class="addthis_button_'+this.obj.addthis+'" title="'+this.obj.alt+'" name="lpos=share['+this.obj.name+']&lid=link[]">' + this.obj.name + '</a>';
			}
			if (i == abcNewsShare.tools.sites.length-1 && this.shareLabels < abcNewsShare.tools.sites.length) this.divTmp = this.divTmp + '</div>';
			document.write(this.divTmp);
		}
		document.write('<div class="clearboth"><!--empty--></div>');
		document.write('</div>');
		document.write('<div class="wrapper share-more"><a id="'+moreOptionDiv+'" class="toolbar-more" href="#" onclick="tools(\''+moreOptionDiv+'\',\''+moreDiv+'\');return false;">More</a><div class="clearboth"><!--empty--></div></div>');
		//document.write('<div class="clearboth"><!--empty--></div>');
		document.write('<div id="'+moreDiv+'" class="more-tools">');
		document.write('<div class="wrapper">');
		for(i=0;i<this.rowOne;i++){
			this.divTmp = '';
			this.obj = abcNewsShare.moretools.sites[i];
			if(this.rowLabel){
				this.divTmp = this.divTmp + '<a class="addthis_button_'+this.obj.addthis+'" title="'+this.obj.alt+'" name="lpos=share['+this.obj.name+']&lid=link[]">' + this.obj.name + '</a>';
			} else {
				this.divTmp = this.divTmp + '<a class="addthis_button_'+this.obj.addthis+'" title="'+this.obj.alt+'" name="lpos=share['+this.obj.name+']&lid=link[]"></a>';
			}
			document.write(this.divTmp);
		}
		document.write('</div>');
		//document.write('<div class="clearboth"><!--empty--></div>');
		if(this.rowOne<abcNewsShare.moretools.sites.length){
			document.write('<div class="wrapper row2">');
			for(i=this.rowOne;i<abcNewsShare.moretools.sites.length;i++){
				this.divTmp = '';
				this.obj = abcNewsShare.moretools.sites[i];
				
				if(this.rowLabel){
					this.divTmp = this.divTmp + '<a class="addthis_button_'+this.obj.addthis+'" title="'+this.obj.alt+'" name="lpos=share['+this.obj.name+']&lid=link[]">' + this.obj.name + '</a>';
				} else {
					this.divTmp = this.divTmp + '<a class="addthis_button_'+this.obj.addthis+'" title="'+this.obj.alt+'" name="lpos=share['+this.obj.name+']&lid=link[]"></a>';
				}

				document.write(this.divTmp);
			}
			document.write('</div>');
		}
		document.write('<div class="clearboth"><!--empty--></div>');
		document.write('</div>');
	document.write('</div>');
	}
}