function readSPCookie(name) {
	var nameEQ = name + "=";
	var ca = document.cookie.split(';');
	for(var i=0;i < ca.length;i++) {
		var c = ca[i];
		while (c.charAt(0)==' ') c = c.substring(1,c.length);
		if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
	}
	return null;
}

function smartPhoneLoad() {
	var redLoc = false;
	var checkCookie = readSPCookie('abcnews_sp');
	if(checkCookie == null || checkCookie == 'null' || typeof checkCookie == 'undefined') {
		if(navigator.userAgent.match(/iPhone|iPod|Android|Blackberry9530|Pre\//i)) {
			var url = window.location.toString();
			var matchUrl = new RegExp("(http://[^/]+)(/m)?(/[^?/]+/?)?[^?]*[?]?.*?(?:id=([^&]+))?").exec(url);
			var storyDetect = url.search(/story/i);
			var ssDetect = url.search(/slideshow/i);
			var videoDetect = url.search(/playerindex/i);
			if(storyDetect!=-1) {
				var objId = matchUrl[4];
				if(objId==null) {
					redLoc = matchUrl[1]+'/m/';
				} else {	
					redLoc = matchUrl[1]+'/m/story?id=' + objId;
				}
			} else if(ssDetect!=-1) {
				var objId = matchUrl[4];
				if(objId==null) {
					redLoc = matchUrl[1]+'/m/slideshow';
				} else {	
					redLoc = matchUrl[1]+'/m/slideshow?id=' + objId;
				}
			} else if (videoDetect!=-1) {
				alert('We\'re sorry. This media format is not supported by your device.');
				if(document.referrer.indexOf(matchUrl[1])==0){
					redLoc = document.referrer
				} else {
					redLoc = matchUrl[1]+'/m/';
				}
			} else if (matchUrl[3]!=null){
				redLoc = matchUrl[1]+'/m/index?pk=' + matchUrl[3];
			}else {
				redLoc = matchUrl[1]+'/m/';
			}
			if(redLoc){
				window.location.replace(redLoc);	
			}
		}
		else if(navigator.userAgent.match(/iPad/)) {
			var url = window.location.toString();
			var nurl = url;
			if(url.indexOf('/t/')==-1){
				nurl = rewriteT(url);
			}
			if(localStorage.getItem('ipadPromoViewed') != 'true' && window.location.href.indexOf('app=true')==-1){
				window.location.href='/ipad?url='+encodeURIComponent(nurl);
			}
			else if(nurl!=url){
					window.location.href=nurl;
			}
		}
	}
}

var tStoryExp = new RegExp("(/wirestory|/story)","i");
var tSlideshowExp = new RegExp("(/popup|/slideshow)","i");
var tVideoExp = new RegExp("(/video/videoLogin|/video/playerIndex|/video)","i");
var tRecipeExp = new RegExp("/recipe\\?","i");
var tSearchExp = new RegExp("/search\\?searchtext","i");
var tIndexExp = new RegExp("/index","i");
var otherNonIndex = new RegExp("/page|/fullpage|/mailform|/recipeSearch|/watch|.pdf|.doc");
var nwsExternal = new RegExp("(health|topics|blogs)\\.abcnews","i");

function rewriteT(url){
	if(url!=null && url.indexOf('/t/')==-1){
		if(tStoryExp.test(url)){
			return url.replace(tStoryExp, "/t/story");
		} else if(tSlideshowExp.test(url)){
			return url.replace(tSlideshowExp, "/t/slideshow");
		} else if(tVideoExp.test(url)){
			return url.replace(tVideoExp, "/t/video");
		} else if(tRecipeExp.test(url)){
			return url.replace(tRecipeExp, "/t/recipe?");
		} else if(tSearchExp.test(url)){
			return url.replace(tSearchExp, "/t/search?searchtext");
		} else if(tIndexExp.test(url)){
			return url.replace(tIndexExp, "/t/index");
		}
		else if((url.indexOf('abcnews.')!=-1 || url.indexOf('http://')==-1)
			&& !nwsExternal.test(url)
			&& !otherNonIndex.test(url) 
			&& url.indexOf('?')==-1
			&& url.indexOf('#')==-1){
				url = (url.lastIndexOf('/')==(url.length-1)) ? url : url+"/";
				url = url+"t/index";
				return url;
		}
	}
	return url;
}

smartPhoneLoad();
